﻿using System;
using System.IO;
using System.Linq;
using Ifc;
using System.Text;
using System.Xml;
using System.Diagnostics;
using System.Windows.Forms;
using System.Xml.Xsl;

namespace IfcWin
{
    class LocalLibrary
    {
        private static void HandleLastLogEntry()
        {
            string lastLine = File.ReadLines(IfcSettings.logFile).Last();

            if (lastLine.Contains('|'))
            {
                string[] lastLnArr = lastLine.Split('|');              
                if (lastLnArr[1].Trim().Equals("Keine neuen " + Program.dataRequest + " eingetroffen."))
                {                    
                    IfcLog.DeleteLastLine(IfcSettings.logFile);
                    IfcLog.DeleteLastLine(IfcSettings.logFile);

                    IfcLog.WriteLog(IfcSettings.logFile, "| Keine neuen " + Program.dataRequest + " eingetroffen.");
                    //Console.WriteLine(DateTime.Now.ToString() + " : Keine neuen " + Program.dataRequest + " eingetroffen.");
                }
                //else
                //{
                //    IfcLog.WriteLog(IfcSettings.logFile, "| Keine neuen " + Program.dataRequest + " eingetroffen.");
                //    Console.WriteLine(DateTime.Now.ToString() + " : Keine neuen " + Program.dataRequest + " eingetroffen.");
                //}
            }
            //else
            //{
            //    IfcLog.WriteLog(IfcSettings.logFile, "| Keine neuen " + Program.dataRequest + " eingetroffen.");
            //    Console.WriteLine(DateTime.Now.ToString() + " : Keine neuen " + Program.dataRequest + " eingetroffen.");
            //}
        }
       
        public static void RequestData()
        {                      
            try
            {
                string retrievedRes = "";
                retrievedRes = IfcNet.SendRQandGetRS(IfcOTAMessage.OTA_ReadRQ(), "https://extranet.hotel-spider.ch/ota/OTA_ReadRQ/2014A", IfcSettings.logFile);
                //retrievedRes = IfcNet.SendRQandGetRS(IfcOTAMessage.OTA_ReadRQ(), "https://staging.hotel-spider.ch/ota/OTA_ReadRQ/2014A", IfcSettings.logFile);



                //// fuer Testzwecke
                //retrievedRes = File.ReadAllText(IfcSettings.ifcPath + "TestReservations.txt");
                //XmlDocument xmlDocTest = new XmlDocument();
                //xmlDocTest.LoadXml(retrievedRes);
                //xmlDocTest.Save(IfcSettings.ifcPath + "NewReservations.txt");
                //retrievedRes = File.ReadAllText(IfcSettings.ifcPath + "NewReservations.txt");
                //retrievedRes = retrievedRes.Substring(retrievedRes.IndexOf('\n') + 1);



                if (IfcOTA.RSSuccess(retrievedRes, IfcSettings.logFile).Equals("Success"))
                {
                    // Wenn mehr als Success ankommt
                    int numLines = retrievedRes.Split('\n').Length;

                    if (numLines > 5)
                    {
                        // Make the retrieved XML-like string valid for parsing
                        retrievedRes = IfcXML.MakeXmlValid(retrievedRes, "ReceivedReservations");
                        
                        // Ausgabe des Status in die Log-Datei und in Console
                        IfcLog.WriteLog(IfcSettings.logFile, "Es sind neue " + Program.dataRequest + " eingetroffen.");
                        Console.WriteLine(DateTime.Now.ToString() + " : Es sind neue " + Program.dataRequest + " eingetroffen:");

                        // Schreibe in Log, zunächst erstelle Ordner, wenn nicht forhanden
                        if (!Directory.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\SpiderLog\\"))
                            Directory.CreateDirectory(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\SpiderLog\\");
                        string logFileName = DateTime.Now.ToString("yyyyMMddHHmmss");

                        XmlDocument xmlDoc = new XmlDocument();
                        xmlDoc.LoadXml(retrievedRes);
                        xmlDoc.Save(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\SpiderLog\\" + logFileName + ".log");
                        
                        // Bearbeite die empfangenen Reservierungen / Stornierungen
                        ParseReservations(retrievedRes, IfcSettings.logFile);
                    }
                    else
                    {
                        IfcLog.WriteLog(IfcSettings.logFile, " | Keine neuen " + Program.dataRequest + " eingetroffen.");
                        Console.WriteLine(DateTime.Now.ToString() + " : Keine neuen " + Program.dataRequest + " eingetroffen.");
                    }
                }
                else if (IfcOTA.RSSuccess(retrievedRes, IfcSettings.logFile).Equals("Error"))
                {
                    // Bei Fehlern
                    IfcLog.WriteOTALog(retrievedRes, "", IfcSettings.logFile);
                }
                else
                {
                    IfcLog.WriteLog(IfcSettings.logFile, "Fehlerhafte Daten wurden empfangen: " + retrievedRes);
                }

                HandleLastLogEntry();
            }
            catch (Exception ex)
            {
                IfcLog.WriteLog(IfcSettings.logFile, ex);               
            }          
        }

        private static string RemoveDoubleSpaceCharacters(string text)
        {
            return System.Text.RegularExpressions.Regex.Replace(text, "[ ]+", " ");
        }

        private static string[] IniArray(string[] strArr)
        {
            for (int i = 0; i < strArr.Length; i++)
            {
                strArr[i] = "";
            }

            return strArr;
        }

        private static double[] IniArray(double[] strArr)
        {
            for (int i = 0; i < strArr.Length; i++)
            {
                strArr[i] = 0;
            }

            return strArr;
        }

        private static int[] IniArray(int[] strArr)
        {
            for (int i = 0; i < strArr.Length; i++)
            {
                strArr[i] = 0;
            }

            return strArr;
        }

        private static string[,] IniArray(string[,] strArr)
        {
            for (int i = 0; i < strArr.GetLength(0); i++)
            {
                for (int n = 0; n < strArr.GetLength(1) - 1; n++)
                {
                    strArr[i,n] = "";
                }
            }

            return strArr;
        }

        public static void ParseReservations(string xmlString, string logFile)
        {          
            string fileName = "";          
            string reservation = "";
            string bookingNumber = "";

            string resID_SourceContext = "";
            string resID_Type = "";
            string resID_Value = "";

            string fullName = "";
            string lastRoomType = "";
            string[,] multRoomType = new string[10, 15];             
            string[] status = new string[3]; // 0 Book ; 1 Cancel ; 2 Modify
            string[] roomType = new string[3];
            string[] resArray = new string[76];
            string[] bookingNumbers = new string[400];
            string[] checkedBookingNumbers = new string[400];
            string[] singleBookingNumber = new string[3];
            string[] singleBookingNumberChecked = new string[3];
            double[] amountSum = new double[3];
            int[] roomCount = new int[3];
            int[] roomStayCount = new int[3];
            int bNCounter = 0;
            int nameCount = 0;
            int reservationCount = 0;
            int diffRoomTypes = 0;
            int guestCount = 0;
            bool globalInfo = false; // for global informations          
            bool isRate = false;
            bool isArrivalDate = true;
            bool isSpecRequest = false;
            bool isComment = false;
            bool isCompanyName = false;

            multRoomType = IniArray(multRoomType);
            amountSum = IniArray(amountSum);
            roomCount = IniArray(roomCount);
            roomStayCount = IniArray(roomStayCount);
            status = IniArray(status);
            roomType = IniArray(roomType);
            resArray = IniArray(resArray);
            bookingNumbers = IniArray(bookingNumbers);
            checkedBookingNumbers = IniArray(checkedBookingNumbers);
            singleBookingNumber = IniArray(singleBookingNumber);
            singleBookingNumberChecked = IniArray(singleBookingNumberChecked);

            using (XmlReader xmlReader = XmlReader.Create(new StringReader(xmlString)))
            {               
                try
                {
                    // Parse the file.
                    while (xmlReader.Read())
                    {
                        if (xmlReader.NodeType == XmlNodeType.Element)
                        {
                            switch (xmlReader.Name)
                            {
                                case "RoomStays":                                   
                                    if (reservationCount > 0)
                                    {                                        
                                        if (status[0].Equals("Book") && !status[1].Equals("Cancel") && !status[2].Equals("Modify"))
                                        {                                           
                                            for (int i = 0; i < multRoomType.GetLength(0); i++)
                                            {
                                                if (!multRoomType[i,9].Equals(""))
                                                {
                                                    resArray[21] = multRoomType[i,0];
                                                    resArray[23] = multRoomType[i,1];
                                                    resArray[20] = multRoomType[i,2];
                                                    resArray[22] = multRoomType[i,3];
                                                    resArray[26] = multRoomType[i,4];
                                                    resArray[27] = multRoomType[i,5];
                                                    resArray[75] = multRoomType[i,6];
                                                    if (!multRoomType[i,7].Equals("") && (resArray[29].Equals("") || !resArray[29].Equals(multRoomType[i, 7]))) resArray[29] = multRoomType[i,7];
                                                    resArray[30] = multRoomType[i,8];
                                                    resArray[70] = multRoomType[i,9];

                                                    if (!resArray[21].Equals(""))
                                                    {
                                                        if (!resArray[10].Equals("")) resArray[0] = resArray[10];
                                                        if (!resArray[11].Equals("")) resArray[1] = resArray[11];
                                                        if (!resArray[12].Equals("")) resArray[2] = resArray[12];
                                                        if (!resArray[13].Equals("")) resArray[3] = resArray[13];
                                                        if (!resArray[14].Equals("")) resArray[4] = resArray[14];
                                                        if (!resArray[15].Equals("")) resArray[5] = resArray[15];
                                                        if (!resArray[16].Equals("")) resArray[6] = resArray[16];
                                                        if (!resArray[17].Equals("")) resArray[7] = resArray[17];
                                                        if (!resArray[18].Equals("")) resArray[8] = resArray[18];
                                                        if (!resArray[19].Equals("")) resArray[9] = resArray[19];

                                                        resArray[10] = "";
                                                        resArray[11] = "";
                                                        resArray[12] = "";
                                                        resArray[13] = "";
                                                        resArray[14] = "";
                                                        resArray[15] = "";
                                                        resArray[16] = "";
                                                        resArray[17] = "";
                                                        resArray[18] = "";
                                                        resArray[19] = "";
                                                    }
                                                    else if (!resArray[23].Equals(""))
                                                    {
                                                        if (!resArray[0].Equals("")) resArray[10] = resArray[0];
                                                        if (!resArray[1].Equals("")) resArray[11] = resArray[1];
                                                        if (!resArray[2].Equals("")) resArray[12] = resArray[2];
                                                        if (!resArray[3].Equals("")) resArray[13] = resArray[3];
                                                        if (!resArray[4].Equals("")) resArray[14] = resArray[4];
                                                        if (!resArray[5].Equals("")) resArray[15] = resArray[5];
                                                        if (!resArray[6].Equals("")) resArray[16] = resArray[6];
                                                        if (!resArray[7].Equals("")) resArray[17] = resArray[7];
                                                        if (!resArray[8].Equals("")) resArray[18] = resArray[8];
                                                        if (!resArray[9].Equals("")) resArray[19] = resArray[9];

                                                        resArray[0] = "";
                                                        resArray[1] = "";
                                                        resArray[2] = "";
                                                        resArray[3] = "";
                                                        resArray[4] = "";
                                                        resArray[5] = "";
                                                        resArray[6] = "";
                                                        resArray[7] = "";
                                                        resArray[8] = "";
                                                        resArray[9] = "";
                                                    }

                                                    // create CSV-file
                                                    reservation = "";
                                                    for (int n = 0; n < resArray.Length; n++)
                                                    {
                                                        reservation = reservation + resArray[n] + ",";
                                                    }
                                                    
                                                    File.WriteAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + multRoomType[i, 9] + ".RIN", reservation, Encoding.Default);
                                                    IfcLog.WriteLog(IfcSettings.logFile, "New Reservation: " + reservation);
                                                    bNCounter = bNCounter + i;
                                                    checkedBookingNumbers[bNCounter] = resArray[70];

                                                    // Buchungsnummer Reservierung nach Vollstaendigkeit ueberpruefen und online bestaetigen
                                                    singleBookingNumber[0] = bookingNumber;
                                                    singleBookingNumberChecked[0] = resArray[70];
                                                    if (Program.confirmation && Program.singleConfirmation) CheckBookingNumbersAndSend(singleBookingNumber, singleBookingNumberChecked);
                                                }
                                            }
                                            
                                            // Für die Bestätigung der Buchungen
                                            bookingNumbers[bNCounter] = bookingNumber;
                                            bNCounter++;
                                        }                                           
                                        else if (status[1].Equals("Cancel"))
                                        {
                                            //create CSV-file
                                            for (int i = 0; i < resArray.Length; i++)
                                            {
                                                reservation = reservation + resArray[i] + ",";
                                            }

                                            if (!Directory.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Cancelled\\"))
                                                Directory.CreateDirectory(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Cancelled\\");

                                            File.WriteAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Cancelled\\" + fileName + ".CAN", reservation, Encoding.Default);
                                            IfcLog.WriteLog(IfcSettings.logFile, "Cancelled Reservation: " + reservation);

                                            // Für die Bestätigung der Stornierungen
                                            singleBookingNumber[0] = bookingNumber;
                                            if (Program.confirmation && Program.singleConfirmation) SendCanAndMod(singleBookingNumber);

                                            bookingNumbers[bNCounter] = bookingNumber;
                                            bNCounter++;
                                            string[] msgBookingFirst = bookingNumber.Split('|');
                                            string[] msgBookingNo = msgBookingFirst[0].Split(';');
                                            string bookingNumberStr = msgBookingNo[2] + " " + msgBookingNo[6];

                                            File.WriteAllText(IfcSettings.ifcPath + "Message.txt", "Folgende Reservierung wurde storniert: " + Environment.NewLine +
                                                    "Buchungsnummer: " + bookingNumberStr + Environment.NewLine +
                                                    "Firma: " + resArray[31] + Environment.NewLine +
                                                    "Name: " + resArray[72] + " " + resArray[33] + Environment.NewLine +
                                                    "Ankunft: " + resArray[29] + Environment.NewLine +
                                                    "Bitte überprüfen sie ihre Emails.");
                                            
                                            if (File.Exists(IfcSettings.ifcPath + "IfcMessage.exe"))
                                            {
                                                Process externalMessageBox = new Process();
                                                externalMessageBox.StartInfo.FileName = IfcSettings.ifcPath + "IfcMessage.exe";
                                                externalMessageBox.Start();

                                                // zwei Sekunden warten, damit die IfcMessage.exe bei mehreren Durchlaefen die richtige Daten erhaelt. Sonst zu schnell
                                                System.Threading.Thread.Sleep(2000);
                                            }
                                        }
                                        else if (status[2].Equals("Modify"))
                                        {
                                            //create CSV-file
                                            for (int i = 0; i < resArray.Length; i++)
                                            {
                                                reservation = reservation + resArray[i] + ",";
                                            }

                                            if (!Directory.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Modified\\"))
                                                Directory.CreateDirectory(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Modified\\");

                                            File.WriteAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Modified\\" + fileName + ".MOD", reservation, Encoding.Default);
                                            IfcLog.WriteLog(IfcSettings.logFile, "Modified Reservation: " + reservation);

                                            // Für die Bestätigung der Modifizierungen
                                            singleBookingNumber[0] = bookingNumber;
                                            if (Program.confirmation && Program.singleConfirmation) SendCanAndMod(singleBookingNumber);

                                            bookingNumbers[bNCounter] = bookingNumber;
                                            bNCounter++;

                                            string[] msgBookingFirst = bookingNumber.Split('|');
                                            string[] msgBookingNo = msgBookingFirst[0].Split(';');
                                            string bookingNumberStr = msgBookingNo[2] + " " + msgBookingNo[6];

                                            File.WriteAllText(IfcSettings.ifcPath + "Message.txt", "Folgende Reservierung wurde geändert: " + Environment.NewLine +
                                                    "Buchungsnummer: " + bookingNumberStr + Environment.NewLine +
                                                    "Firma: " + resArray[31] + Environment.NewLine +
                                                    "Name: " + resArray[72] + " " + resArray[33] + Environment.NewLine +
                                                    "Ankunft: " + resArray[29] + Environment.NewLine +
                                                    "Bitte überprüfen sie ihre Emails.");
                                            
                                            if (File.Exists(IfcSettings.ifcPath + "IfcMessage.exe"))
                                            {
                                                Process externalMessageBox = new Process();
                                                externalMessageBox.StartInfo.FileName = IfcSettings.ifcPath + "IfcMessage.exe";
                                                externalMessageBox.Start();

                                                // zwei Sekunden warten, damit die IfcMessage.exe bei mehreren Durchlaefen die richtige Daten erhaelt. Sonst zu schnell
                                                System.Threading.Thread.Sleep(2000);
                                            }
                                        }
                                            
                                        // lösche Informationen der Reservierung
                                        fileName = "";                                       
                                        nameCount = 0;
                                        reservation = "";
                                        bookingNumber = "";
                                        lastRoomType = "";
                                        resID_SourceContext = "";
                                        resID_Type = "";
                                        resID_Value = "";
                                        diffRoomTypes = 0;
                                        guestCount = 0;
                                        globalInfo = false;
                                        isRate = false;
                                        isArrivalDate = true;
                                        isSpecRequest = false;
                                        isComment = false;
                                        isCompanyName = false;
                                        amountSum = IniArray(amountSum);
                                        roomCount = IniArray(roomCount);
                                        roomStayCount = IniArray(roomStayCount);
                                        status = IniArray(status);
                                        roomType = IniArray(roomType);
                                        resArray = IniArray(resArray);
                                        multRoomType = IniArray(multRoomType);                                       
                                    }
                                    reservationCount++;                                  
                                    break;
                                case "HotelReservation":
                                    if (xmlReader.HasAttributes)
                                    {
                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("ResStatus"))
                                            {
                                                if (xmlReader.Value.Equals("Book") || xmlReader.Value.Equals("Booked"))
                                                {
                                                    //status[0] = xmlReader.Value;
                                                    status[0] = "Book";
                                                }
                                                else if (xmlReader.Value.Equals("Cancel") || xmlReader.Value.Equals("Cancelled"))
                                                {
                                                    //status[1] = xmlReader.Value;
                                                    status[1] = "Cancel";
                                                }
                                                else if (xmlReader.Value.Equals("Modify") || xmlReader.Value.Equals("Modified"))
                                                {
                                                    //status[2] = xmlReader.Value;
                                                    status[2] = "Modify";
                                                }
                                            }
                                        }
                                        xmlReader.MoveToElement();
                                    } // End of If element has attributes                                  
                                    break;
                                case "RoomStay":                                   
                                    if (xmlReader.HasAttributes)
                                    {
                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("RoomStayStatus"))
                                            {
                                                if (xmlReader.Value.Equals("Book") || xmlReader.Value.Equals("Booked"))
                                                {
                                                    //status[0] = xmlReader.Value;
                                                    status[0] = "Book";
                                                }
                                                else if(xmlReader.Value.Equals("Cancel") || xmlReader.Value.Equals("Cancelled"))
                                                {
                                                    //status[1] = xmlReader.Value;
                                                    status[1] = "Cancel";
                                                }
                                                else if (xmlReader.Value.Equals("Modify") || xmlReader.Value.Equals("Modified"))
                                                {
                                                    //status[2] = xmlReader.Value;
                                                    status[2] = "Modify";
                                                }
                                            }                                              
                                        }
                                        xmlReader.MoveToElement();
                                    } // End of If element has attributes                                  
                                    break;
                                case "RoomType":                               
                                    if (xmlReader.HasAttributes)
                                    {
                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("RoomID"))
                                            {
                                                try
                                                {
                                                    // Ordne den empfangenen Zimmertyp EZ oder DZ zu
                                                    roomType[0] = IfcDBF.GetRoomType(xmlReader.Value, "Spider");

                                                    string[] roomTypeArr = roomType[0].Split(',');

                                                    // Wenn neuer Zimmertyp
                                                    if (!lastRoomType.Equals(roomTypeArr[1]) && !lastRoomType.Equals(""))
                                                    {
                                                        diffRoomTypes++;

                                                        guestCount = 0;
                                                        amountSum = IniArray(amountSum);
                                                        roomCount = IniArray(roomCount);
                                                        roomStayCount = IniArray(roomStayCount);
                                                    }
                                                    lastRoomType = roomTypeArr[1];

                                                    int diffRoomTypesBuffer = diffRoomTypes + 1;
                                                    multRoomType[diffRoomTypes, 9] = "_" + diffRoomTypesBuffer;

                                                    if (roomTypeArr[0].Equals("EZ"))
                                                    {
                                                        resArray[21] = roomTypeArr[1];
                                                        roomType[1] = roomTypeArr[0];
                                                        roomType[2] = "";
                                                        roomCount[1]++;
                                                        roomType[0] = "";
                                                        multRoomType[diffRoomTypes, 0] = roomTypeArr[1];
                                                        multRoomType[diffRoomTypes, 2] = roomCount[1].ToString();
                                                    }
                                                    else if (roomTypeArr[0].Equals("DZ") || roomTypeArr[0].Equals("MBZ"))
                                                    {
                                                        resArray[23] = roomTypeArr[1];
                                                        roomType[2] = roomTypeArr[0];
                                                        roomType[1] = "";
                                                        roomCount[2]++;
                                                        roomType[0] = "";
                                                        multRoomType[diffRoomTypes, 1] = roomTypeArr[1];
                                                        multRoomType[diffRoomTypes, 3] = roomCount[2].ToString();
                                                    }
                                                } catch (Exception ex)
                                                {
                                                    IfcLog.WriteLog(IfcSettings.logFile, "Beim Einlesen der Zimmernummer gab es ein Problem. Zimmernummer: " + xmlReader.Value + "; Error: "+ ex);
                                                }
                                            }
                                        }
                                        xmlReader.MoveToElement();
                                    } // End of If element has attributes                                     
                                    break;
                                case "GuestCounts":
                                    isRate = false;                                                              
                                    break;
                                case "GuestCount":
                                    if (!globalInfo)
                                    {
                                        if (xmlReader.HasAttributes)
                                        {
                                            for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                            {
                                                xmlReader.MoveToAttribute(attInd);

                                                if (xmlReader.Name.Equals("Count"))
                                                {
                                                    int guestCountBuffer = Convert.ToInt16(xmlReader.Value);
                                                    guestCount = guestCount + guestCountBuffer;
                                                    // Anzahl Gäste im jeweiligen Zimmer (Feld 76)     
                                                    resArray[75] = guestCount.ToString();
                                                    multRoomType[diffRoomTypes, 6] = resArray[75];
                                                }
                                            }
                                            xmlReader.MoveToElement();
                                        } // End of If element has attributes
                                    }
                                    break;
                                case "Rate":
                                    isRate = true;
                                    //globalInfo = false;
                                    break;                               
                                case "ResGlobalInfo":
                                    globalInfo = true;
                                    break;                                
                                case "TimeSpan":
                                    isRate = false;
                                    if (globalInfo)
                                    {
                                        if (xmlReader.HasAttributes)
                                        {
                                            for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                            {
                                                xmlReader.MoveToAttribute(attInd);

                                                if (xmlReader.Name.Equals("Start"))
                                                {
                                                    // Ankunftsdatum wird formatiert und übernommen     
                                                    resArray[29] = DateTime.Parse(xmlReader.Value).ToString("dd'.'MM'.'yyyy");
                                                    multRoomType[diffRoomTypes, 7] = resArray[29];
                                                }
                                                if (xmlReader.Name.Equals("Duration"))
                                                {
                                                    TimeSpan ts = XmlConvert.ToTimeSpan(xmlReader.Value);
                                                    resArray[30] = ts.Days.ToString();
                                                    multRoomType[diffRoomTypes, 8] = resArray[30];
                                                }
                                            }
                                            xmlReader.MoveToElement();
                                        } // End of If element has attributes                                       
                                    }
                                    else // fuer jedes Zimmer einzeln                                   
                                    if (!globalInfo)
                                    {
                                        if (xmlReader.HasAttributes)
                                        {
                                            for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                            {
                                                xmlReader.MoveToAttribute(attInd);

                                                if (xmlReader.Name.Equals("Start") && isArrivalDate)
                                                {
                                                    // Ankunftsdatum wird formatiert und übernommen     
                                                    resArray[29] = DateTime.Parse(xmlReader.Value).ToString("dd'.'MM'.'yyyy");
                                                    isArrivalDate = false;
                                                    multRoomType[diffRoomTypes,7] = resArray[29];
                                                }
                                                if (xmlReader.Name.Equals("Duration"))
                                                {
                                                    TimeSpan ts = XmlConvert.ToTimeSpan(xmlReader.Value);
                                                    resArray[30] = ts.Days.ToString();
                                                    multRoomType[diffRoomTypes,8] = resArray[30];

                                                    // Aufenthaltsdauer wird übernommen  
                                                    if (roomType[1].Equals("EZ"))
                                                    {
                                                        int roomStay = Convert.ToInt16(ts.Days);
                                                        roomStayCount[1] = roomStayCount[1] + roomStay;
                                                    }
                                                    else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                                    {
                                                        int roomStay = Convert.ToInt16(ts.Days);
                                                        roomStayCount[2] = roomStayCount[2] + roomStay;
                                                    }
                                                    
                                                    // Anzahl der Uebernachtungen und Gesamtpreis eintragen   
                                                    double tagespreis = 0;

                                                    if (roomType[1].Equals("EZ"))
                                                    {
                                                        if (roomCount[1] > 0)
                                                        {
                                                            resArray[20] = roomCount[1].ToString();
                                                            multRoomType[diffRoomTypes, 2] = resArray[20];

                                                            //Berechnung Tagespreis EZ                                          
                                                            if (amountSum[1] > 0)
                                                            {
                                                                if (resArray[30].Equals("") || resArray[30].Equals(" "))
                                                                {
                                                                    tagespreis = amountSum[1] / roomCount[1] / (roomStayCount[1] / roomCount[1]);
                                                                }
                                                                else
                                                                {
                                                                    byte days = Byte.Parse(resArray[30]);
                                                                    tagespreis = amountSum[1] / roomCount[1] / days;
                                                                }
                                                                tagespreis = Math.Round(tagespreis, 2);
                                                            }

                                                            resArray[26] = tagespreis.ToString();

                                                            if (resArray[26].Contains(",") || resArray[26].Contains("."))
                                                            {
                                                                resArray[26] = resArray[26].Replace(",", "").Replace(".", "").Remove(resArray[26].Length - 2);
                                                            }
                                                            
                                                            multRoomType[diffRoomTypes, 4] = resArray[26];
                                                        }
                                                    }
                                                    else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                                    {                                                        
                                                        if (roomCount[2] > 0)
                                                        {
                                                            resArray[22] = roomCount[2].ToString();
                                                            multRoomType[diffRoomTypes, 3] = resArray[22];

                                                            //Berechnung Tagespreis DZ                                          
                                                            if (amountSum[2] > 0)
                                                            {
                                                                if (resArray[30].Equals("") || resArray[30].Equals(" "))
                                                                {
                                                                    tagespreis = amountSum[2] / roomCount[2] / (roomStayCount[2] / roomCount[2]);
                                                                }
                                                                else
                                                                {
                                                                    byte days = Byte.Parse(resArray[30]);
                                                                    tagespreis = amountSum[2] / roomCount[2] / days;
                                                                }

                                                                resArray[27] = tagespreis.ToString();

                                                                if (resArray[27].Contains(",") || resArray[27].Contains("."))
                                                                {
                                                                    resArray[27] = resArray[27].Replace(",", "").Replace(".", "").Remove(resArray[27].Length - 2);
                                                                }

                                                                multRoomType[diffRoomTypes, 5] = resArray[27];                                                              
                                                            }
                                                        }
                                                    }                                                  
                                                }
                                            }
                                            xmlReader.MoveToElement();
                                        } // End of If element has attributes    
                                    }
                                    break;
                                case "Total":                                  
                                    if (isRate)
                                    {
                                        if (xmlReader.HasAttributes)
                                        {
                                            for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                            {
                                                xmlReader.MoveToAttribute(attInd);

                                                if (xmlReader.Name.Equals("AmountAfterTax"))
                                                {
                                                    // Uebernachtungspreis summieren                                   
                                                    if (roomType[1].Equals("EZ"))
                                                    {
                                                        double dayAmount = Convert.ToDouble(xmlReader.Value);
                                                        amountSum[1] = amountSum[1] + dayAmount;
                                                    }
                                                    else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                                    {
                                                        double dayAmount = Convert.ToDouble(xmlReader.Value);
                                                        amountSum[2] = amountSum[2] + dayAmount;
                                                    }
                                                }
                                                if (xmlReader.Name.Equals("CurrencyCode"))
                                                {
                                                    resArray[25] = xmlReader.Value;
                                                }
                                                xmlReader.MoveToElement();
                                            }
                                        } // End of If element has attributes 
                                    }                                  
                                    break;
                                case "HotelReservationID":
                                    if (xmlReader.HasAttributes)
                                    {
                                        resID_Value = "";

                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("ResID_SourceContext")) resID_SourceContext = xmlReader.Value;
                                            else if (xmlReader.Name.Equals("ResID_Type")) resID_Type = xmlReader.Value;
                                            else if (xmlReader.Name.Equals("ResID_Value")) resID_Value = xmlReader.Value;

                                            if (resID_Type.Equals("14") && !resID_Value.Equals("") && !resID_SourceContext.Equals("") && bookingNumber.Equals(""))
                                            {
                                                resArray[42] = resID_SourceContext;
                                                resArray[70] = resID_Value;
                                                fileName = resID_Value;
                                                
                                                for (int i = 0; i < multRoomType.GetLength(0); i++)
                                                {
                                                    if (!multRoomType[i, 9].Equals("")) multRoomType[i, 9] = resArray[70] + multRoomType[i, 9];
                                                }

                                                bookingNumber = DateTime.Now.ToString("yyMMddhhmm") + ";ResID_SourceContext;" + resID_SourceContext + ";ResID_Type;" + resID_Type + ";ResID_Value;" + resID_Value;

                                                resID_SourceContext = "";
                                                resID_Type = "";
                                                resID_Value = "";
                                            }
                                            else if (resID_Type.Equals("14") && !resID_Value.Equals("") && !resID_SourceContext.Equals(""))
                                            {
                                                resArray[42] = resID_SourceContext;                                           
                                                resArray[70] = resID_Value;
                                                fileName = resID_Value;

                                                for (int i = 0; i < multRoomType.GetLength(0); i++)
                                                {
                                                    if (!multRoomType[i, 9].Equals("")) multRoomType[i, 9] = resArray[70] + multRoomType[i, 9];
                                                }

                                                bookingNumber = DateTime.Now.ToString("yyMMddhhmm") + ";ResID_SourceContext;" + resID_SourceContext + ";ResID_Type;" + resID_Type + ";ResID_Value;" + resID_Value + bookingNumber;

                                                resID_SourceContext = "";
                                                resID_Type = "";
                                                resID_Value = "";
                                            }
                                            else if (resID_Type.Equals("34") && !resID_Value.Equals("") && !resID_SourceContext.Equals(""))
                                            {
                                                resID_Type = "40";                          
                                                bookingNumber = bookingNumber + "|ResID_SourceContext;SEMPER;ResID_Type;10;ResID_Value;" + reservationCount + DateTime.Now.ToString("yyMMddhhmm") + "|ResID_SourceContext;" + resID_SourceContext + ";ResID_Type;" + resID_Type + ";ResID_Value;" + resID_Value;

                                                resID_SourceContext = "";
                                                resID_Type = "";
                                                resID_Value = "";
                                            }
                                        }
                                        xmlReader.MoveToElement();
                                    }                                   
                                    globalInfo = true;                                   
                                    break;                              
                                case "BookingChannel":
                                    isCompanyName = false;
                                    break;
                                case "CompanyInfo":
                                    isCompanyName = true;
                                    break;
                                case "CompanyName":
                                    if (isCompanyName)
                                    {
                                        // read next node
                                        xmlReader.Read();
                                        resArray[31] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                        if (resArray[31].Equals(" ")) resArray[31] = "";
                                    }                                    
                                    break;                        
                                case "PersonName":
                                    if (!globalInfo) nameCount++;
                                    break;
                                case "GivenName":
                                    // read next node
                                    xmlReader.Read();
                                    if (globalInfo) // Reservierer
                                    {                                  
                                        resArray[72] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                        if (resArray[72].Equals(" ")) resArray[72] = "";
                                    } else // Zimmerbelegung
                                    {
                                        if (nameCount <= 5)
                                        {
                                            fullName = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                            if (fullName.Equals(" ")) fullName = "";
                                                                                       

                                            if (roomType[1].Equals("EZ"))
                                            {
                                                resArray[4 + nameCount] = fullName.Trim();
                                            }
                                            else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                            {
                                                resArray[14 + nameCount] = fullName.Trim();
                                            }
                                        }  
                                        else
                                        {
                                            resArray[71] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' ')) + " " + resArray[71];
                                            if (resArray[71].Equals(" ")) resArray[71] = "";
                                        }                                                                             
                                    }                                   
                                    break;
                                case "Surname":
                                    // read next node
                                    xmlReader.Read();
                                    if (globalInfo) // Reservierer
                                    {
                                        resArray[33] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                        if (resArray[33].Equals(" ")) resArray[33] = "";
                                    }
                                    else // Zimmerbeleger
                                    {
                                        if (nameCount <= 5)
                                        {
                                            string nameBuffer = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                            if (nameBuffer.Equals(" ")) nameBuffer = "";

                                            fullName = fullName + " " + nameBuffer;

                                            if (roomType[1].Equals("EZ"))
                                            {
                                                resArray[4 + nameCount] = fullName.Trim();
                                            }
                                            else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                            {
                                                resArray[14 + nameCount] = fullName.Trim();
                                            }
                                        }
                                        else
                                        {
                                            resArray[71] = nameCount + ". Gast: " + RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' ')) + ";" + resArray[71];
                                            if (resArray[71].Equals(" ")) resArray[71] = "";
                                        }
                                    }
                                    fullName = "";
                                    break;
                                case "AddressLine":
                                    // read next node
                                    xmlReader.Read();
                                    resArray[34] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                    if (resArray[34].Equals(" ")) resArray[34] = "";
                                    break;
                                case "PostalCode":
                                    // read next node
                                    xmlReader.Read();
                                    resArray[37] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                    if (resArray[37].Equals(" ")) resArray[36] = "";
                                    break;
                                case "CityName":
                                    // read next node
                                    xmlReader.Read();
                                    resArray[38] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                    if (resArray[38].Equals(" ")) resArray[38] = "";
                                    break;
                                case "CountryName":
                                    if (xmlReader.HasAttributes)
                                    {
                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("Code"))
                                            {
                                                resArray[36] = xmlReader.Value.ToUpper();                                             
                                                resArray[35] = IfcTools.GetCountryNameFromCode(resArray[36]);
                                                resArray[73] = IfcTools.ChangeCountryCode(resArray[36]);
                                            }
                                        }
                                        xmlReader.MoveToElement();
                                    } // End of If element has attributes
                                    else
                                    {
                                        // read next node
                                        xmlReader.Read();                                       
                                        string country = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' ')).Trim();
                                        
                                        if (country.Trim().Length < 4)
                                        {
                                            resArray[73] = xmlReader.Value.ToUpper();
                                            resArray[35] = IfcTools.GetCountryNameFromCode(resArray[73]);
                                            resArray[36] = IfcTools.ChangeCountryCode(resArray[73]);
                                        }                                       
                                        else
                                        {
                                            resArray[35] = country;
                                            if (resArray[35].Equals(" ")) resArray[35] = "";
                                        }                                     
                                    }
                                    if (resArray[35].Equals(" ")) resArray[35] = "";
                                    break;
                                case "Telephone":
                                    //// read next node
                                    //xmlReader.Read();
                                    if (xmlReader.HasAttributes)
                                    {
                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("PhoneNumber"))
                                            {
                                                resArray[39] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                                if (resArray[39].Equals(" ")) resArray[39] = "";
                                            }
                                            
                                        }
                                        xmlReader.MoveToElement();
                                    } // End of If element has attributes                                  
                                    break;
                                case "Email":
                                    // read next node
                                    xmlReader.Read();
                                    resArray[41] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                    if (resArray[41].Equals(" ")) resArray[41] = "";
                                    break;                                      
                                case "PaymentCard":
                                    if (xmlReader.HasAttributes)
                                    {
                                        for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                        {
                                            xmlReader.MoveToAttribute(attInd);

                                            if (xmlReader.Name.Equals("CardNumber"))
                                            {
                                                resArray[44] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                                if (resArray[44].Equals(" ")) resArray[44] = "";
                                            }
                                            if (xmlReader.Name.Equals("ExpireDate"))
                                            {
                                                resArray[45] = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ' '));
                                                if (resArray[45].Equals(" ")) resArray[45] = "";
                                            }
                                        }
                                        xmlReader.MoveToElement();
                                    } // End of If element has attributes                                                                      
                                    break;                               
                                case "Comments":
                                    isComment = true;
                                    isSpecRequest = false;                                   
                                    break;
                                case "Comment":
                                    isComment = true;
                                    isSpecRequest = false;                                   
                                    break;
                                case "RoomRateDescription":
                                    isComment = false;
                                    isSpecRequest = false;
                                    break;
                                case "DetailDescription":
                                    // read next node
                                    xmlReader.Read();                                   
                                    xmlReader.Read(); // <Text>   
                                   
                                    resArray[71] = resArray[71] + Environment.NewLine + RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ';'));
                                    break;
                                //case "Amenities":
                                //    // read next node
                                //    xmlReader.Read();
                                //    if (roomType[1].Equals("EZ"))
                                //    {
                                //        resArray[71] = resArray[71] + Environment.NewLine + roomCount[1].ToString() + ". Zimmer: ";
                                //    }
                                //    else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                //    {
                                //        resArray[71] = resArray[71] + Environment.NewLine + roomCount[2].ToString() + ". Zimmer: ";
                                //    }
                                //        break;
                                //case "Amenity":                                   
                                //    // read next node
                                //    xmlReader.Read(); // empty node                                                                      
                                //    resArray[71] = resArray[71] + RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ';')) + ";";
                                //    if (resArray[71].Equals(" ")) resArray[71] = "";
                                //    break;
                                case "SpecialRequest":
                                    isSpecRequest = true;
                                    //isComment = false;
                                    //string specReq = "";
                                    //if (xmlReader.HasAttributes)
                                    //{
                                    //    for (int attInd = 0; attInd < xmlReader.AttributeCount; attInd++)
                                    //    {
                                    //        xmlReader.MoveToAttribute(attInd);

                                    //        if (xmlReader.Name.Equals("Name"))
                                    //        {
                                    //            specReq = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ';'));
                                    //            //resArray[71] = resArray[71] + Environment.NewLine + specReq + ": ";

                                    //            if (roomType[1].Equals("EZ"))
                                    //            {
                                    //                resArray[71] = resArray[71] + roomCount[1].ToString() + ". Zimmer: " + specReq + ": ";
                                    //            }
                                    //            else if (roomType[2].Equals("DZ") || roomType[2].Equals("MBZ"))
                                    //            {
                                    //                resArray[71] = resArray[71] + roomCount[2].ToString() + ". Zimmer: " + specReq + ": ";
                                    //            }
                                    //        }
                                    //    }
                                    //    xmlReader.MoveToElement();
                                    //} // End of If element has attributes               
                                    break;
                                case "Text":
                                    xmlReader.Read();
                                    if (isSpecRequest)
                                    {
                                        if (!resArray[71].Equals(xmlReader.Value + "; ")) resArray[71] = resArray[71] + xmlReader.Value + "; ";

                                        if (xmlReader.Value.Trim().Equals("Non-Smoking")) resArray[46] = "J";
                                    }
                                    //else if (isComment)
                                    else if (globalInfo)
                                    {
                                        string newComment = RemoveDoubleSpaceCharacters(xmlReader.Value.Replace("\r\n", "").Replace("\n", "").Replace("\r", "").Replace(',', ';'));

                                        if (newComment.Equals("This reservation has been guaranteed."))
                                        {
                                            resArray[43] = "J";
                                        }

                                        //resArray[71] = newComment + Environment.NewLine + resArray[71];
                                        resArray[71] =   resArray[71] + Environment.NewLine + newComment;
                                        if (resArray[71].Equals(" ")) resArray[71] = "";
                                    }                                   
                                    break;                               
                            }                           
                        } // End of If node is element                        
                    }
                }
                catch (XmlException ex)
                {
                    IfcLog.WriteLog(logFile, "Fehler beim Lesen der Reservierungen. Error: " + ex);
                }
            }

            // create CSV-file
            for (int i = 0; i < resArray.Length; i++)
            {
                reservation = reservation + resArray[i] + ",";
            }

            if (status[0].Equals("Book") && !status[1].Equals("Cancel") && !status[2].Equals("Modify"))
            {
                for (int i = 0; i < multRoomType.GetLength(0); i++)
                {
                    if (!multRoomType[i, 9].Equals(""))
                    {
                        // MessageBox.Show(diffRoomTypes.ToString());

                        //MessageBox.Show(diffRoomTypes + "    " + multRoomType[i, 9]);

                        resArray[21] = multRoomType[i,0];
                        resArray[23] = multRoomType[i,1];
                        resArray[20] = multRoomType[i,2];
                        resArray[22] = multRoomType[i,3];
                        resArray[26] = multRoomType[i,4];
                        resArray[27] = multRoomType[i,5];
                        resArray[75] = multRoomType[i,6];
                        if (!multRoomType[i, 7].Equals("") && (resArray[29].Equals("") || !resArray[29].Equals(multRoomType[i, 7]))) resArray[29] = multRoomType[i, 7];
                        resArray[30] = multRoomType[i,8];
                        resArray[70] = multRoomType[i,9];

                        if (!resArray[21].Equals(""))
                        {
                            if (!resArray[10].Equals("")) resArray[0] = resArray[10];
                            if (!resArray[11].Equals("")) resArray[1] = resArray[11];
                            if (!resArray[12].Equals("")) resArray[2] = resArray[12];
                            if (!resArray[13].Equals("")) resArray[3] = resArray[13];
                            if (!resArray[14].Equals("")) resArray[4] = resArray[14];
                            if (!resArray[15].Equals("")) resArray[5] = resArray[15];
                            if (!resArray[16].Equals("")) resArray[6] = resArray[16];
                            if (!resArray[17].Equals("")) resArray[7] = resArray[17];
                            if (!resArray[18].Equals("")) resArray[8] = resArray[18];
                            if (!resArray[19].Equals("")) resArray[9] = resArray[19];

                            resArray[10] = "";
                            resArray[11] = "";
                            resArray[12] = "";
                            resArray[13] = "";
                            resArray[14] = "";
                            resArray[15] = "";
                            resArray[16] = "";
                            resArray[17] = "";
                            resArray[18] = "";
                            resArray[19] = "";
                        }
                        else if (!resArray[23].Equals(""))
                        {
                            if (!resArray[0].Equals("")) resArray[10] = resArray[0];
                            if (!resArray[1].Equals("")) resArray[11] = resArray[1];
                            if (!resArray[2].Equals("")) resArray[12] = resArray[2];
                            if (!resArray[3].Equals("")) resArray[13] = resArray[3];
                            if (!resArray[4].Equals("")) resArray[14] = resArray[4];
                            if (!resArray[5].Equals("")) resArray[15] = resArray[5];
                            if (!resArray[6].Equals("")) resArray[16] = resArray[6];
                            if (!resArray[7].Equals("")) resArray[17] = resArray[7];
                            if (!resArray[8].Equals("")) resArray[18] = resArray[8];
                            if (!resArray[9].Equals("")) resArray[19] = resArray[9];

                            resArray[0] = "";
                            resArray[1] = "";
                            resArray[2] = "";
                            resArray[3] = "";
                            resArray[4] = "";
                            resArray[5] = "";
                            resArray[6] = "";
                            resArray[7] = "";
                            resArray[8] = "";
                            resArray[9] = "";
                        }

                        // create CSV-file
                        reservation = "";
                        for (int n = 0; n < resArray.Length; n++)
                        {
                            reservation = reservation + resArray[n] + ",";
                        }

                        File.WriteAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + multRoomType[i, 9] + ".RIN", reservation, Encoding.Default);
                        IfcLog.WriteLog(IfcSettings.logFile, "New Reservation: " + reservation);

                        bNCounter = bNCounter + i;
                        checkedBookingNumbers[bNCounter] = resArray[70];

                        // Buchungsnummer Reservierung nach Vollstaendigkeit ueberpruefen und online bestaetigen
                        singleBookingNumber[0] = bookingNumber;
                        singleBookingNumberChecked[0] = resArray[70];
                        if (Program.confirmation && Program.singleConfirmation) CheckBookingNumbersAndSend(singleBookingNumber, singleBookingNumberChecked);
                    }
                }

                // Für die Bestätigung der Buchungen
                bookingNumbers[bNCounter] = bookingNumber;                        
            }
            else if(status[1].Equals("Cancel"))
            {
                //create CSV-file
                for (int i = 0; i < resArray.Length; i++)
                {
                    reservation = reservation + resArray[i] + ",";
                }

                if (!Directory.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Cancelled\\"))
                    Directory.CreateDirectory(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Cancelled\\");

                File.WriteAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\\\Spider\\Cancelled\\" + fileName + ".CAN", reservation, Encoding.Default);
                IfcLog.WriteLog(IfcSettings.logFile, "Cancelled Reservation: " + reservation);

                // Für die Bestätigung der Stornierungen
                singleBookingNumber[0] = bookingNumber;
                if (Program.confirmation && Program.singleConfirmation) SendCanAndMod(singleBookingNumber);

                bookingNumbers[bNCounter] = bookingNumber;

                string[] msgBookingFirst = bookingNumber.Split('|');
                string[] msgBookingNo = msgBookingFirst[0].Split(';');
                string bookingNumberStr = msgBookingNo[2] + " " + msgBookingNo[6];

                File.WriteAllText(IfcSettings.ifcPath + "Message.txt", "Folgende Reservierung wurde storniert: " + Environment.NewLine +
                                                    "Buchungsnummer: " + bookingNumberStr + Environment.NewLine +
                                                    "Firma: " + resArray[31] + Environment.NewLine +
                                                    "Name: " + resArray[72] + " " + resArray[33] + Environment.NewLine +
                                                    "Ankunft: " + resArray[29] + Environment.NewLine +
                                                    "Bitte überprüfen sie ihre Emails.");
                
                if (File.Exists(IfcSettings.ifcPath + "IfcMessage.exe"))
                {
                    Process externalMessageBox = new Process();
                    externalMessageBox.StartInfo.FileName = IfcSettings.ifcPath + "IfcMessage.exe";
                    externalMessageBox.Start();

                    // zwei Sekunden warten, damit die IfcMessage.exe bei mehreren Durchlaefen die richtige Daten erhaelt. Sonst zu schnell
                    System.Threading.Thread.Sleep(2000);
                }
            }
            else if (status[2].Equals("Modify"))
            {
                //create CSV-file
                for (int i = 0; i < resArray.Length; i++)
                {
                    reservation = reservation + resArray[i] + ",";
                }

                if (!Directory.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Modified\\"))
                    Directory.CreateDirectory(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Modified\\");

                File.WriteAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\Spider\\Modified\\" + fileName + ".MOD", reservation, Encoding.Default);
                IfcLog.WriteLog(IfcSettings.logFile, "Modified Reservation: " + reservation);

                // Für die Bestätigung der Modifizierungen
                singleBookingNumber[0] = bookingNumber;
                if (Program.confirmation && Program.singleConfirmation) SendCanAndMod(singleBookingNumber);

                bookingNumbers[bNCounter] = bookingNumber;

                string[] msgBookingFirst = bookingNumber.Split('|');
                string[] msgBookingNo = msgBookingFirst[0].Split(';');
                string bookingNumberStr = msgBookingNo[2] + " " + msgBookingNo[6];

                File.WriteAllText(IfcSettings.ifcPath + "Message.txt", "Folgende Reservierung wurde geändert: " + Environment.NewLine +
                                                    "Buchungsnummer: " + bookingNumberStr + Environment.NewLine +
                                                    "Firma: " + resArray[31] + Environment.NewLine +
                                                    "Name: " + resArray[72] + " " + resArray[33] + Environment.NewLine +
                                                    "Ankunft: " + resArray[29] + Environment.NewLine +
                                                    "Bitte überprüfen sie ihre Emails.");

                if (File.Exists(IfcSettings.ifcPath + "IfcMessage.exe"))
                {
                    Process externalMessageBox = new Process();
                    externalMessageBox.StartInfo.FileName = IfcSettings.ifcPath + "IfcMessage.exe";
                    externalMessageBox.Start();

                    // zwei Sekunden warten, damit die IfcMessage.exe bei mehreren Durchlaefen die richtige Daten erhaelt. Sonst zu schnell
                    System.Threading.Thread.Sleep(2000);
                }                   
            }

            //try
            //{
            //    File.WriteAllLines(IfcSettings.ifcPath + "BookingNumbers.txt", bookingNumbers);
            //    // Schreibe liste der neuen Reservierungen in TXT-Datei - loesche dann auch alle leeren Zeilen
            //    File.WriteAllLines(IfcSettings.ifcPath + "BookingNumbersAll.txt", checkedBookingNumbers.Where(l => !string.IsNullOrWhiteSpace(l)));
            //    //File.WriteAllLines(IfcSettings.ifcPath + "BookingNumbersAll.txt", checkedBookingNumbers);


            //    // checke Dateien auf Vollstaendigkeit
            //    checkedBookingNumbers = CheckBookingNumbers("Spider", checkedBookingNumbers);

            //    // Schreibe liste der neuen Reservierungen in TXT-Datei - loesche dann auch alle leeren Zeilen
            //    File.WriteAllLines(IfcSettings.ifcPath + "ResCon.txt", bookingNumbers.Where(l => !string.IsNullOrWhiteSpace(l)));
            //    // nimm die Resievierungliste und erstelle XML der geschickt werden soll
            //    string[] allBookingNumbers = File.ReadAllLines(IfcSettings.ifcPath + "ResCon.txt");
            //    string resNumXML = IfcOTAMessage.ResDataString(allBookingNumbers);

            //    File.WriteAllText(IfcSettings.ifcPath + "ResConXML.txt", IfcOTAMessage.OTA_HotelResNotifRS(resNumXML, allBookingNumbers[0]));
            //    string confimStr = File.ReadAllText(IfcSettings.ifcPath + "ResConXML.txt");


            //    //SendConfirmation(confimStr);


            //    IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang folgender Nummern wurden besätigt:" + Environment.NewLine + File.ReadAllText(IfcSettings.ifcPath + "ResCon.txt"));
            //}
            //catch (Exception ex)
            //{
            //    IfcLog.WriteLog(IfcSettings.logFile, "Bei der Bestätigung der Reservierungen gab es ein Problem. Zwischen den Buchungsnummern: " + bookingNumbers.First() + "; " + bookingNumbers.Last() + "; Error: "+ ex);
            //}


            if (Program.confirmation && !Program.singleConfirmation) CheckBookingNumbersAndSend(bookingNumbers, checkedBookingNumbers);


           
            if (File.Exists(IfcSettings.ifcPath + "NewReservations.txt")) File.Delete(IfcSettings.ifcPath + "NewReservations.xml");
            if (File.Exists(IfcSettings.ifcPath + "Message.txt")) File.Delete(IfcSettings.ifcPath + "Message.txt");
        }

        public static void SendCanAndMod(string[] bookingNumbers)
        {
            try
            {
                // Schreibe liste der neuen Reservierungen in TXT-Datei - loesche dann auch alle leeren Zeilen
                File.WriteAllLines(IfcSettings.ifcPath + "ResCon.txt", bookingNumbers.Where(l => !string.IsNullOrWhiteSpace(l)));
                // nimm die Resievierungliste und erstelle XML der geschickt werden soll
                string[] allBookingNumbers = File.ReadAllLines(IfcSettings.ifcPath + "ResCon.txt");
                string resNumXML = IfcOTAMessage.ResDataString(allBookingNumbers);

                File.WriteAllText(IfcSettings.ifcPath + "ResConXML.txt", IfcOTAMessage.OTA_HotelResNotifRS(resNumXML, allBookingNumbers[0]));
                string confimStr = File.ReadAllText(IfcSettings.ifcPath + "ResConXML.txt");


                SendConfirmation(confimStr);


                IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang folgender Nummern wurden besätigt:" + File.ReadAllText(IfcSettings.ifcPath + "ResCon.txt"));

                if (File.Exists(IfcSettings.ifcPath + "ResCon.txt")) File.Delete(IfcSettings.ifcPath + "ResCon.txt");
                //if (File.Exists(IfcSettings.ifcPath + "ResConXML.txt")) File.Delete(IfcSettings.ifcPath + "ResConXML.txt");
            }
            catch (Exception ex)
            {
                IfcLog.WriteLog(IfcSettings.logFile, "Bei der Bestätigung der Stornierung bzw. Modifiyierung gab es ein Problem. Bei der Buchungsnummer: " + bookingNumbers.First() + "; Error: " + ex);
            }
        }

        public static void CheckBookingNumbersAndSend(string[] bookingNumbers, string[] checkedBookingNumbers)
        {
            try
            {
                File.WriteAllLines(IfcSettings.ifcPath + "BookingNumbers.txt", bookingNumbers);
                // Schreibe liste der neuen Reservierungen in TXT-Datei - loesche dann auch alle leeren Zeilen
                File.WriteAllLines(IfcSettings.ifcPath + "BookingNumbersAll.txt", checkedBookingNumbers.Where(l => !string.IsNullOrWhiteSpace(l)));
                //File.WriteAllLines(IfcSettings.ifcPath + "BookingNumbersAll.txt", checkedBookingNumbers);


                // checke Dateien auf Vollstaendigkeit
                checkedBookingNumbers = CheckBookingNumbers("Spider", checkedBookingNumbers);

                // Schreibe liste der neuen Reservierungen in TXT-Datei - loesche dann auch alle leeren Zeilen
                File.WriteAllLines(IfcSettings.ifcPath + "ResCon.txt", bookingNumbers.Where(l => !string.IsNullOrWhiteSpace(l)));
                // nimm die Resievierungliste und erstelle XML der geschickt werden soll
                string[] allBookingNumbers = File.ReadAllLines(IfcSettings.ifcPath + "ResCon.txt");
                string resNumXML = IfcOTAMessage.ResDataString(allBookingNumbers);

                File.WriteAllText(IfcSettings.ifcPath + "ResConXML.txt", IfcOTAMessage.OTA_HotelResNotifRS(resNumXML, allBookingNumbers[0]));
                string confimStr = File.ReadAllText(IfcSettings.ifcPath + "ResConXML.txt");


                SendConfirmation(confimStr);


                IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang folgender Nummern wurden besätigt:" + File.ReadAllText(IfcSettings.ifcPath + "ResCon.txt"));

                if (File.Exists(IfcSettings.ifcPath + "ResCon.txt")) File.Delete(IfcSettings.ifcPath + "ResCon.txt");
                //if (File.Exists(IfcSettings.ifcPath + "ResConXML.txt")) File.Delete(IfcSettings.ifcPath + "ResConXML.txt");
            }
            catch (Exception ex)
            {
                IfcLog.WriteLog(IfcSettings.logFile, "Bei der Bestätigung der Reservierungen gab es ein Problem. Zwischen den Buchungsnummern: " + bookingNumbers.First() + "; " + bookingNumbers.Last() + "; Error: " + ex);
            }
        }

        public static void SendConfirmation(string otaMessage)
        {
            string conResponse = "";
            conResponse = IfcNet.SendRQandGetRS(otaMessage, "https://extranet.hotel-spider.ch/ota/OTA_HotelResNotifRS/2014A", IfcSettings.logFile);

            // Antwort in die Log-Datei eintragen
            IfcLog.WriteLog(IfcSettings.logFile, ResRSSuccess(conResponse, IfcSettings.logFile));         
        }

        public static string ResRSSuccess(string xmlString, string logFile)
        {
            Boolean error = true;
            string result = "";
            // Create an XmlReader
            if (xmlString != null)
            {
                using (XmlReader xmlReader = XmlReader.Create(new StringReader(xmlString)))
                {
                    try
                    {
                        // Parse the String and return each of the nodes.
                        while ((xmlReader.Read()) && (error))
                        {
                            if ((xmlReader.NodeType == XmlNodeType.Element) && xmlReader.Name.Equals("Success"))
                            {
                                result = xmlReader.Name;
                                error = false;
                            }
                            else
                            {
                                if ((xmlReader.NodeType == XmlNodeType.Element) && xmlReader.Name.Equals("Error"))
                                {
                                    result = xmlReader.Name;
                                }
                                if (xmlReader.NodeType == XmlNodeType.Text)
                                {
                                    result = xmlReader.Name + xmlReader.Value;
                                }
                            }
                        }
                    }
                    catch (XmlException ex)
                    {
                        IfcLog.WriteLog(logFile, ex);
                        return "";
                    }
                }
            } // End of If
            return result;
        }

        public static string[] CheckBookingNumbers(string directory, string[] bookingNumbersArr)
        {
            string[] checkedValues = new string[400];
            int counter = 0;

            for (int i = 0; i < checkedValues.Length - 1; i++)
            {
                checkedValues[i] = " ";
            }
            
            foreach (string number in bookingNumbersArr)
            {
                if (!number.Equals(""))
                {
                    //string[] numArrFirst = numberArr.Split('|');
                    //string[] numArr = numArrFirst[0].Split(';');

                    // gehe zum ersten ResID_Value
                    //int i = 0;
                    //while (!numArr[i].Equals("ResID_Value") && i < numArr.Length - 2) i++;

                    //string number = numArr[i + 1];

                    if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN") ||
                        File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN") ||
                        File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD") ||
                        File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS"))

                    {
                        string resToCheck = "";
                        if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN")) resToCheck = File.ReadAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN");
                        else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN")) resToCheck = File.ReadAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN");
                        else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD")) resToCheck = File.ReadAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD");
                        else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS")) resToCheck = File.ReadAllText(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS");

                        string[] resToCheckValues = resToCheck.Split(',');

                        if (resToCheckValues.Length > 70)
                        {
                            if (resToCheckValues[20].Equals("") && resToCheckValues[22].Equals("")) // Zimmeranzahl nicht vorhanden
                            {
                                IfcLog.WriteLog(IfcSettings.logFile, "Zimmeranzahl für die Reservierung: " + number + " fehlt!");
                                IncompleteDAT(resToCheckValues, "Zimmeranzahl", directory);
                            }
                            else if (resToCheckValues[21].Equals("") && resToCheckValues[23].Equals("")) // Zimmertyp nicht vorhanden
                            {
                                IfcLog.WriteLog(IfcSettings.logFile, "Zimmertyp für die Reservierung: " + number + " fehlt!");
                                IncompleteDAT(resToCheckValues, "Zimmertyp", directory);
                            }
                            else if (resToCheckValues[26].Equals("") && resToCheckValues[27].Equals("")) // Preis nicht vorhanden
                            {
                                IfcLog.WriteLog(IfcSettings.logFile, "Preis für die Reservierung: " + number + " fehlt!");
                                IncompleteDAT(resToCheckValues, "Preis", directory);
                            }
                            else if (resToCheckValues[29].Equals("") || resToCheckValues[30].Equals("")) // Datum oder Uebernachtungen nicht vorhanden
                            {
                                IfcLog.WriteLog(IfcSettings.logFile, "Ankunftsdatum und/oder Übernachtungen für die Reservierung: " + number + " fehlen!");
                                IncompleteDAT(resToCheckValues, "Ankunftsdatum und/oder Übernachtungen", directory);
                            }
                            else if (resToCheckValues[31].Equals("") && resToCheckValues[33].Equals("")) // Besteller nicht vorhanden
                            {
                                IfcLog.WriteLog(IfcSettings.logFile, "Name des Bestellers für die Reservierung: " + number + " fehlt!");
                                IncompleteDAT(resToCheckValues, "Name des Bestellers", directory);
                            }
                            else
                            {
                                if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN"))
                                    IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang der Reservierung: " + number + " wurde erfolgreich bestätigt.");
                                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN"))
                                    IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang der Stornierung: " + number + " wurde erfolgreich bestätigt.");
                                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD"))
                                    IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang der Modifizierung: " + number + " wurde erfolgreich bestätigt.");
                                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS"))
                                    IfcLog.WriteLog(IfcSettings.logFile, "Der Eingang des No Shows: " + number + " wurde erfolgreich bestätigt.");

                                checkedValues[counter] = number;
                                counter++;

                                if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN"))
                                {
                                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".DAT", true);
                                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + number + ".RIN");
                                }
                                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN"))
                                {
                                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CANC", true);
                                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + number + ".CAN");
                                }
                                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD"))
                                {
                                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MODC", true);
                                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + number + ".MOD");
                                }
                                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS"))
                                {
                                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOSC", true);
                                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + number + ".NOS");
                                }
                            }
                        }
                        else IfcLog.WriteLog(IfcSettings.logFile, "Bei der Bearbeitung/Bestätigung der Reservierungen ist ein Problem aufgetreten. Die Größe der CSV-Dat-Datei ist falsch!");
                    }
                }
            }

            return checkedValues;
        }

        private static void IncompleteDAT(string[] resArray, string gap, string directory)
        {
            if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + resArray[70] + ".RIN"))
            {
                if (!Directory.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\IncomplRes\\"))
                    Directory.CreateDirectory(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\IncomplRes\\");

                File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + resArray[70] + ".RIN", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\IncomplRes\\" + resArray[70] + ".ERR", true);
                File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + resArray[70] + ".RIN");

                // MessageBox Meldung
                File.WriteAllText(IfcSettings.ifcPath + "Message.txt", "ACHTUNG! Folgende Reservierung ist nicht vollständig: " + Environment.NewLine +
                                                    "Buchungsnummer: " + resArray[70] + " " + resArray[42] + Environment.NewLine +
                                                    "Firma: " + resArray[31] + Environment.NewLine +
                                                    "Name: " + resArray[72] + " " + resArray[33] + Environment.NewLine +
                                                    "Ankunft: " + resArray[29] + Environment.NewLine + Environment.NewLine +
                                                    gap + " nicht forhanden!" + Environment.NewLine + Environment.NewLine +
                                                    "Bitte überprüfen sie ihre Emails.");

                if (File.Exists(IfcSettings.ifcPath + "IfcMessage.exe"))
                {
                    Process externalMessageBox = new Process();
                    externalMessageBox.StartInfo.FileName = IfcSettings.ifcPath + "IfcMessage.exe";
                    externalMessageBox.Start();

                    // zwei Sekunden warten, damit die IfcMessage.exe bei mehreren Durchlaefen die richtige Daten erhaelt. Sonst zu schnell
                    System.Threading.Thread.Sleep(2000);
                }
            }
            else
            {
                if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + resArray[70] + ".CAN"))
                {
                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + resArray[70] + ".CAN", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + resArray[70] + ".CANE", true);
                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Cancelled\\" + resArray[70] + ".CAN");
                }
                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + resArray[70] + ".MOD"))
                {
                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + resArray[70] + ".MOD", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + resArray[70] + ".MODE", true);
                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\Modified\\" + resArray[70] + ".MOD");
                }
                else if (File.Exists(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + resArray[70] + ".NOS"))
                {
                    File.Copy(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + resArray[70] + ".NOS", IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + resArray[70] + ".NOSE", true);
                    File.Delete(IfcDBF.DLPath(IfcSettings.localPath) + "\\IFC\\internet\\" + directory + "\\NoShow\\" + resArray[70] + ".NOS");
                }
            }          
        }       
    }
}
