﻿using System;
using System.IO;
using System.Timers;
using System.Windows.Forms;
using Ifc;

namespace IfcWin
{
    class Program
    {
        // Hotelname
        public static string ifcName = "Chanelmanager - Interface";
        // Welche Daten werden abgerufen
        public static string dataRequest = "Reservierungen";
        public static bool singleConfirmation = true;
        public static bool confirmation = true;
        // Hotelspezifische Lizenz-Info
        //public static string license = "Präsentationen (semper 2015)";
        //public static string license = "Hotel Gasthaus Steiger";
        //public static string license = "Hotel L' Escala Betriebs GmbH";

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {            
            if (!File.Exists(IfcSettings.settingsFile))
            {
                MessageBox.Show("Die " + ifcName + " - Konfigurationsdatei fehlt. Bitte wenden sie sich an den Support.", "Fehlermeldung!");
                CloseApplication();
            }
            else if (!File.Exists(IfcSettings.iconFile))
            {
                MessageBox.Show("Die " + ifcName + " - Icon-Datei fehlt. Bitte wenden sie sich an den Support.", "Fehlermeldung!");
                CloseApplication();
            }
            else if (!File.Exists(IfcSettings.localPath + "CONFIG.FPW"))
            {
                MessageBox.Show(IfcSettings.localPath + "CONFIG.FPW fehlt. Bitte wenden sie sich an den Support.", "Fehlermeldung!");
                CloseApplication();
            }
            else
            {
                // Set settings from settings file
                IfcSettings.setConfiguration(IfcSettings.settingsFile);
                ifcName = IfcSettings.ifcName;
                // License Test
                //MessageBox.Show(license + " = " + IfcDBF.CheckLicense(IfcDBF.DBFPath(IfcSettings.hoResConfigPath), IfcSettings.logFile), "Lizenz Information");

                //if (license.Equals(IfcDBF.CheckLicense(IfcDBF.DBFPath(IfcSettings.localPath), IfcSettings.logFile)))
                //{
                //    StartApplication();
                //}
                //else
                //{
                //    MessageBox.Show("Diese Version von " + ifcName + " ist nicht lizensiert! Bitte melden Sie sich beim Support.", "Fehlermeldung!");
                //    CloseApplication();
                //}
                StartApplication();
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new IfcForm());
        }

        // Für vorzeitiges Beenden des Programms
        public static void CloseApplication()
        {
            if (Application.MessageLoop)
            {
                // WinForms app
                Application.Exit();
            }
            else
            {
                // Console app
                Environment.Exit(1);
            }
        }

        private static void StartApplication()
        {            
            IfcLog.WriteLog(IfcSettings.logFile, ifcName + " wurde gestartet.");
            // Bei Monatswechsel wird die Log-Datei archiviert
            IfcLog.CheckLogFile(IfcSettings.logFileName);
            // Initialize and start timer
//            IfcTimer();
        }
                      
        //public static System.Timers.Timer timer;

        //private static void IfcTimer()
        //{
        //    int min = 0;
        //    Int32.TryParse(IfcSettings.minInterval, out min);

        //    // Create a timer
        //    timer = new System.Timers.Timer();
        //    // Set it to go off every five minutes
        //    timer.Interval = min * 60000; // 300000 are 5 minutes;          
        //    // Tell the timer what top do when it elapses
        //    timer.Elapsed += TimerEvent;
        //    // And start it        
        //    timer.Enabled = true;
        //}

        //private static void TimerEvent(Object source, ElapsedEventArgs e)
        //{
        //    // Bei Monatswechsel wird die Log-Datei archiviert
        //    IfcLog.CheckLogFile(IfcSettings.logFileName);
            
        //    IntervalAction();
        //}

        public static void IntervalAction()
        {
            LocalLibrary.RequestData();
        }      
    }
}
