﻿using System;
using System.IO;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace Spider
{
    class HotSpiderSettings
    {        
        public static string avail_s = "av_roomtyp,av_date,av_avail,av_waiting,av_mark,av_definit,av_option,av_tentat,av_allott,av_pick,av_ooorder,av_invtype,av_invcode,av_countyp,av_actype,av_lostime,av_los,av_anzgast,av_agecode,av_price,av_curency,av_decimal,av_ratcode,av_ratier,av_statusp,av_reststa,av_statusr,av_z,av_p,av_r";
        
        public static string localPath = @"C:\HoRes8\Hotel\";
        public static string ifcPath = @"C:\HoRes8\Hotel\ifc\internet\spider\";

        public static string oledb = "F";

        public static string updates = "F";
        public static string rates = "F";
        public static string reservations = "F";

        public static string dBaseIV = "F";
        public static string vfp = "T";

        public static string provider = "Microsoft.Jet.OLEDB.4.0";
        public static string extProperties = "dBASE IV;";

        public static string vfpProvider = "VFPOLEDB";
        public static string extended = "";

        public static string requestorID = "Semper";
        public static string messagePassword = "aBruzywS7I";
        public static string id_context = "HoRes";
        public static string companyName = "Semper Hotelsoftware";

        public static string hotelCode = "";//"2582";
        public static string hotelName = "";//"Semper Test Hotel";

        public static string bookingChannel = "4";
        public static string minIntervall = "5";
        public static string password = "";

        public static string dnsTestName = "www.google.com";

        public static string logFileName = "IfcLog";
        public static string settingsFile = AppDomain.CurrentDomain.BaseDirectory + "IfcSettings.ini";
        public static string logFile = AppDomain.CurrentDomain.BaseDirectory + logFileName + ".Log";
        public static string iconFile = AppDomain.CurrentDomain.BaseDirectory + "IFC.ICO";

        public static void setConfiguration()
        {
            string[] strArray = null;
            string line = null;
            
            System.IO.StreamReader file =
               new System.IO.StreamReader(settingsFile);

            while ((line = file.ReadLine()) != null)
            {
                strArray = line.Split('=');
                switch (strArray[0])
                {
                    case "avail_S":
                        avail_s = strArray[1];
                        break;
                    case "localPath":
                        if (!strArray[1].Equals(""))
                            localPath = strArray[1];
                        break;
                    case "ifcPath":
                        if (!strArray[1].Equals(""))
                            ifcPath = strArray[1];
                        break;
                    case "oleDb":
                        if (!strArray[1].Equals(""))
                            oledb = strArray[1];
                        break;
                    case "updates":
                        if (!strArray[1].Equals(""))
                            updates = strArray[1];
                        break;
                    case "rates":
                        if (!strArray[1].Equals(""))
                            rates = strArray[1];
                        break;
                    case "reservations":
                        if (!strArray[1].Equals(""))
                            reservations = strArray[1];
                        break;
                    case "dBaseIV":
                        if (!strArray[1].Equals(""))
                            dBaseIV = strArray[1];
                        break;
                    case "Visual Foxpro":
                        if (!strArray[1].Equals(""))
                            vfp = strArray[1];
                        break;
                    case "Provider":
                        if (!strArray[1].Equals(""))
                            provider = strArray[1];
                        break;
                    case "Extended Properties":
                        if (!strArray[1].Equals(""))
                            extProperties = strArray[1];
                        break;
                    case "ProviderVFP":
                        if (!strArray[1].Equals(""))
                            vfpProvider = strArray[1];
                        break;
                    case "Extended":
                        if (!strArray[1].Equals(""))
                            extended = strArray[1];
                        break;
                    case "requestorID":
                        if (!strArray[1].Equals(""))
                            requestorID = strArray[1];
                        break;
                    case "messagePassword":
                        if (!strArray[1].Equals(""))
                            messagePassword = strArray[1];
                        break;
                    case "idContext":
                        if (!strArray[1].Equals(""))
                            id_context = strArray[1];
                        break;
                    case "companyName":
                        if (!strArray[1].Equals(""))
                            companyName = strArray[1];
                        break;
                    case "hotelCode":
                        hotelCode = strArray[1];
                        break;
                    case "hotelName":
                        hotelName = strArray[1];
                        break;
                    case "bookingChannel":
                        if (!strArray[1].Equals(""))
                            bookingChannel = strArray[1];
                        break;
                    case "min":
                        if (!strArray[1].Equals(""))
                            minIntervall = strArray[1];
                        break;
                    case "DNSTest":
                        dnsTestName = strArray[1];
                        break;
                    case "password":
                        if (!strArray[1].Equals(""))
                            password = strArray[1];
                        break;
                }
            }
            file.Close();
        }       
    }
}
