﻿using System;
using System.Text;
using System.Net;
using System.IO;
using System.Data;
using System.Data.OleDb;
using System.Xml;
using System.Xml.Xsl;
using System.Xml.Linq;
using System.Linq;
using System.Windows.Forms;
using System.Globalization;
using System.Collections.Generic;

namespace Spider
{
    class HotelInterfaceTools
    {
        public static string TimeStamp()
        {
            DateTime dtNow = DateTime.Now;
            return String.Format("{0:s}", dtNow);
        }

        public static bool DnsTestSuc(string checkSite)
        {
            try
            {
                IPHostEntry iphe = Dns.GetHostEntry(checkSite);
                return true;
            }
            catch
            {
                return false;
            }
        }

        public static void RSuccessNoResDelLastLog(string status, string message, string logFile, byte minusLastLines)
        {
            // Löscht die letzten Einträge der Log-Datei, wenn Reservierungen erfolgreich abgefragt wurden aber keine Reservierungen da waren
            if (File.Exists(logFile))
            {
                string lastLogLine = File.ReadLines(logFile).Last();
                string[] strArray = null;
                strArray = lastLogLine.Split(',');

                if (strArray[1].Trim().Equals(status) & strArray[2].Trim().Equals(message))
                {
                    var lines = File.ReadAllLines(logFile);
                    File.WriteAllLines(logFile, lines.Take(lines.Length - minusLastLines).ToArray());
                    WriteLog(status + ", " + message);
                }
            }
        }

        public static bool isLogStatus(string status, byte statusColumn, string message, byte messageColumn, string logFile)
        {
            if (File.Exists(logFile))
            {
                string[] lines = File.ReadAllLines(logFile);
                string oneBeforelastLogLine = lines[lines.Length - 2];

                if (oneBeforelastLogLine.Contains(","))
                {
                    string[] strArray = null;
                    strArray = oneBeforelastLogLine.Split(',');

                    if (strArray.Length > 2)
                    {
                        if (strArray[statusColumn].Trim().Equals(status) & strArray[messageColumn].Trim().Equals(message))
                            return true;
                        else return false;
                    }
                    else return false;
                }
                else return false;
            }
            else return false;
        }

        public static string SendRQandGetRS(string soap, string uri)
        {
            // send request
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(uri);
            req.ServerCertificateValidationCallback += (sender, certificate, chain, sslPolicyErrors) => { return true; };
            req.ContentType = "application/soap+xml;";
            req.Method = "POST";

            using (Stream stm = req.GetRequestStream())
            {
                using (StreamWriter stmw = new StreamWriter(stm))
                {
                    try
                    {
                        stmw.Write(soap);
                    }
                    catch (WebException ex)
                    {
                        MessageBox.Show("Eine Verbindung mit dem Internet konnte nicht aufgebaut werden. Fehler: " + ex, "Hotel-Spider - Fehlermeldung!");
                        CloseApplication();
                    }
                }
            }

            // receive response and write to string
            WebResponse response = req.GetResponse();
            Stream responseStream = response.GetResponseStream();

            XmlTextReader reader = new XmlTextReader(responseStream);
            StringBuilder sb = new StringBuilder();
            try
            {
                while (reader.Read())
                {
                    sb.AppendLine(reader.ReadOuterXml());
                }
            }
            catch (XmlException ex)
            {
                WriteLog("RuntimeError: " + ex);
                MessageBox.Show("Ein Problem beim Empfangen einer Nachricht ist aufgetreten. Bitte versuchen sie es zu einem späteren Zeitpunkt wieder. Wenden sie sich bitte an den Support, wenn der Fehler weiterhin auftritt.", "Hotel-Spider - Fehlermeldung!");
                CloseApplication();
            }
            return sb.ToString();
        }

        public static void WriteDataLog(String csvString, String fileName)
        {
            string logPath = getPath(HotSpiderSettings.localPath, "LOG") + "log\\";
            DateTime today = DateTime.Now;

            // Erstelle Log-Ordner, wenn nicht vorhanden
            if (!Directory.Exists(logPath)) Directory.CreateDirectory(logPath);

            // Für jedes Jahr neuen Ordner
            string filePath = logPath + fileName + "_" + today.Year.ToString() + "\\";
            if (!Directory.Exists(filePath)) Directory.CreateDirectory(filePath);

            // Die Log-Datein werden mit Jahr und Monat versehen
            string fileWithDate = fileName + "_" + today.Year.ToString() + "-" + today.Month.ToString();
            if (!File.Exists(filePath + fileWithDate + ".csv"))
            {
                switch (fileName)
                {
                    case "Rooms":
                        csvString = "Timestamp,Typ,Typcode,Anzahl,Zähltyp,Verteilungstyp,von,bis" + Environment.NewLine + csvString;
                        break;
                    case "Rates":
                        csvString = "Timestamp,Typ,Invcode,Typcode,Preiscode,Preisschicht,Status,Gaeste,Alterscode,Preis,Dezimalstellen,Waehrung,von,bis" + Environment.NewLine + csvString;
                        break;
                    case "Restrictions":
                        csvString = "Timestamp,Typ,Typcode,Preiscode,LengthOfStay,Days,Restriction,Status,von,bis" + Environment.NewLine + csvString;
                        break;
                }

            }

            try
            {
                using (StreamWriter w = File.AppendText(filePath + fileWithDate + ".csv"))
                {
                    w.WriteLine(csvString);
                }
            }
            catch (IOException ex)
            {
                WriteLog("RuntimeError: " + ex);
                MessageBox.Show("Ein Problem beim Schreiben in eine Daten-Log-Datei ist aufgetreten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                CloseApplication();
            }
        }

        public static void WriteLog(string msg)
        {
            try
            {
                using (StreamWriter w = File.AppendText(getPath(HotSpiderSettings.localPath, "LOG") + "IfcLog.Log"))
                {
                    w.WriteLine(DateTime.Now + ", " + msg);
                }
            }
            catch (IOException ex)
            {
                MessageBox.Show("Fehler beim Schreiben in die spider.Log. Bitte wenden sie sich an den Support. RuntimeError: " + ex, "HoRes Hotel-Spider - Reservierungen");
                CloseApplication();
            }
        }

        public static void WriteLog(string xmlString, string msg)
        {
            Boolean error = true;
            // Create an XmlReader
            if (xmlString != null)
            {
                using (XmlReader xmlReader = XmlReader.Create(new StringReader(xmlString)))
                {
                    using (StreamWriter w = File.AppendText(getPath(HotSpiderSettings.localPath, "LOG") + "IfcLog.Log"))
                    {
                        try
                        {
                            // Parse the String and return each of the nodes.
                            while ((xmlReader.Read()) && (error))
                            {
                                if ((xmlReader.NodeType == XmlNodeType.Element) && xmlReader.Name.Equals("Success"))
                                {
                                    w.WriteLine(DateTime.Now + ", " + xmlReader.Name + ", " + msg);
                                    error = false;
                                }
                                else
                                {
                                    if ((xmlReader.NodeType == XmlNodeType.Element) && xmlReader.Name.Equals("Error"))
                                    {
                                        w.Write(DateTime.Now + ", " + xmlReader.Name);
                                    }
                                    if (xmlReader.NodeType == XmlNodeType.Text)
                                    {
                                        w.WriteLine(", " + xmlReader.Value);
                                    }
                                }
                            }
                        }
                        catch (XmlException ex)
                        {
                            WriteLog("Ein Problem beim Schreiben in die Log-Datei ist aufgetreten. RuntimeError: " + ex);
                            MessageBox.Show("Ein Problem beim Schreiben in die Log-Datei ist aufgetreten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                            CloseApplication();
                        }
                    }
                }
            } // End of If  
        }

        public static string RSSuccess(string xmlString)
        {
            Boolean error = true;
            string result = "";
            // Create an XmlReader
            if (xmlString != null)
            {
                using (XmlReader xmlReader = XmlReader.Create(new StringReader(xmlString)))
                {
                    try
                    {
                        // Parse the String and return each of the nodes.
                        while ((xmlReader.Read()) && (error))
                        {
                            if ((xmlReader.NodeType == XmlNodeType.Element) && xmlReader.Name.Equals("Success"))
                            {
                                result = xmlReader.Name;
                                error = false;
                            }
                            else
                            {
                                if ((xmlReader.NodeType == XmlNodeType.Element) && xmlReader.Name.Equals("Error"))
                                {
                                    result = xmlReader.Name;
                                }
                                if (xmlReader.NodeType == XmlNodeType.Text)
                                {
                                    result = xmlReader.Name + xmlReader.Value;
                                }
                            }
                        }
                    }
                    catch (XmlException ex)
                    {
                        WriteLog("RuntimeError: " + ex);
                        MessageBox.Show("Ein Problem beim Empfangen einer Nachricht ist aufgetreten. Wenden sie sich bitte an den Support.", "Hotel-Spider - Fehlermeldung!");
                        CloseApplication();
                    }
                }
            } // End of If
            return result;
        }

        private static DataSet ReadOleDbTable(String path, String qStrSQL)
        {
            // Dies sind nur Vorlagen
            // string connectionString = @"Provider=VFPOLEDB.1;Data Source=" + filepath;
            // string connectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filepath + ";Extended Properties=dBASE IV;";            
            // string connectionString = @"Provider=" + HotSpiderSettings.provider + ";Data Source=" + filepath + ";Extended Properties=" + HotSpiderSettings.extProperties; // ";Persist Security Info=False;Extended Properties=dBASE IV;";

            string connectionString = "";
            DataSet ds = new DataSet();

            if (HotSpiderSettings.dBaseIV.Equals("T")) 
            {
                connectionString = @"Provider=" + HotSpiderSettings.provider + ";Data Source=" + path + ";Extended Properties=" + HotSpiderSettings.extProperties; // dBase IV";    
            }
            else if (HotSpiderSettings.vfp.Equals("T")) 
            {
                connectionString = "Provider=VFPOLEDB;Data Source=" + path + HotSpiderSettings.extended;
            } 
            else
            {
                WriteLog("Wählen sie in der Datei spider.config einen Datenbanktreiber aus (=T).");
                MessageBox.Show("Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                CloseApplication();
            }    

            using (OleDbConnection connection = new OleDbConnection(connectionString))
            using (OleDbCommand command = connection.CreateCommand())
            using (OleDbDataAdapter adapter = new OleDbDataAdapter(command))
            {
                try
                {
                    connection.Open();
                    command.CommandText = qStrSQL;
                    command.ExecuteNonQuery();
                    adapter.Fill(ds);
                }

                catch (OleDbException ex)
                {
                    MessageBox.Show("Fehler beim Lesen der Datei avail_S.dbf : " + ex, "Hotel-Spider");
                }
                finally
                {
                    adapter.Dispose();
                    command.Dispose();
                    connection.Close();
                }
            }
            return ds;
        }

        private static string checkEofMonth(string[] vonStr, string[] bisStr)
        {
            Boolean lastDayOfMonth = false;
            string resultEoM = bisStr[0];

            if (bisStr[0] == "31")
            {
                lastDayOfMonth = true;
            }
            else
            {
                if (bisStr[0] == "30")
                    if ((bisStr[1] == "04") || (bisStr[1] == "06") || (bisStr[1] == "09") || (bisStr[1] == "11"))
                        lastDayOfMonth = true;
                if ((bisStr[0] == "29") && (bisStr[1] == "02"))
                    lastDayOfMonth = true;
                if ((bisStr[0] == "28") && (bisStr[1] == "02"))
                    if ((bisStr[2] == "2016") || (bisStr[2] == "2020") || (bisStr[2] == "2024") || (bisStr[2] == "2028") ||
                        (bisStr[2] == "2032") || (bisStr[2] == "2036") || (bisStr[2] == "2040"))
                        lastDayOfMonth = true;
            }

            if (lastDayOfMonth)
                if (Convert.ToInt16(vonStr[1]) == Convert.ToInt16(bisStr[1]) + 1) // check months
                    resultEoM = "00"; // End of month, "00" for calculation 0+1=1 (first of month)
            return resultEoM;
        }

        public static DataTable UpdateAvailabData(DataTable dt, string chooseA, string chooseB, string chooseC)
        {
            byte countDays = 1;
            string[] vonStrArr = null;
            string[] bisStrArr = null;


            // Create new "von" column
            DataColumn vonCol = dt.Columns.Add("von", typeof(String));
            foreach (DataColumn col in dt.Columns) col.ReadOnly = false;

            // TRIM Leerzeichen in allen Spalten und übertrage Datum- (DateTime) in von-Spalte (String)
            foreach (DataRow dr in dt.Rows)
            {
                foreach (DataColumn col in dt.Columns)
                {
                    if (col.DataType == typeof(System.String))
                    {
                        dr[col] = dr[col].ToString().Trim();
                    }
                }
                DateTime readDate = DateTime.Parse(dr["datum"].ToString());
                dr["von"] = readDate.ToString("yyyy-MM-dd");
            }
            // Lösche Datum-Spalte
            dt.Columns.Remove("datum");

            // Create new new "bis" column
            DataColumn bisCol = dt.Columns.Add("bis", typeof(String));
 //           foreach (DataColumn col in dt.Columns) col.ReadOnly = false;
            DataTable updt = new DataTable();
            updt = dt;
            updt.Rows[0]["bis"] = updt.Rows[0]["von"];
            for (int i = 1; i < dt.Rows.Count; i++)
            {
                vonStrArr = updt.Rows[i]["von"].ToString().Split('-');
                bisStrArr = updt.Rows[i - 1]["bis"].ToString().Split('-');

                if (vonStrArr[2] == "01") bisStrArr[2] = checkEofMonth(vonStrArr, bisStrArr);

                if ((updt.Rows[i][chooseA].Equals(updt.Rows[i - 1][chooseA])) &&
                    (updt.Rows[i][chooseB].Equals(updt.Rows[i - 1][chooseB])) &&
                    (updt.Rows[i][chooseC].Equals(updt.Rows[i - 1][chooseC])) &&
                    (countDays <= 5) &&
                    (Convert.ToInt16(vonStrArr[2]) == Convert.ToInt16(bisStrArr[2]) + 1))
                {
                    updt.Rows[i - 1]["bis"] = updt.Rows[i]["von"];
                    // delete the row after enumerating date 
                    updt.Rows[i].Delete();
                    updt.AcceptChanges();
                    i--;
                    countDays++;
                }
                else
                {
                    updt.Rows[i]["bis"] = updt.Rows[i]["von"];
                    countDays = 0;
                }
                vonStrArr = null;
                bisStrArr = null;
            }

            foreach (DataColumn col in updt.Columns) col.ReadOnly = true;
            return updt;
        }

        public static string getPath(string configPath, string kindOfPath)
        {
            int counter = 0;
            string path = null;
            string[] strArray = null;
            string line = null;

            System.IO.StreamReader file =
               new System.IO.StreamReader(configPath + "CONFIG.FPW");

            while ((line = file.ReadLine()) != null)
            {
                strArray = line.Split('=');
                if (strArray[0] == "Default")
                {
                    if (kindOfPath.Equals("DBF") || kindOfPath.Equals("dbf") || kindOfPath.Equals("Dbf"))
                    {
                        path = strArray[1] + "\\dbf\\";
                    }
                    else if (kindOfPath.Equals("LOG") || kindOfPath.Equals("log") || kindOfPath.Equals("Log"))
                    {
                        path = strArray[1] + "\\ifc\\internet\\spider\\";
                    }
                }
                counter++;
            }
            file.Close();
            return path;
        }

        /*       public static string ReadOleDbAsXML(string von, string bis)
               {
                   string qStrAvail = "SELECT TRIM(av_roomtyp) AS Typ, TRIM(av_waiting) AS Anz, FORMAT(av_date, 'YYYY-MM-DD') AS von FROM avail_S WHERE av_waiting > 0 AND av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";

                   // Read DBF-DB         
                   DataSet dsAvailab = new DataSet();
                   dsAvailab = ReadOleDbTable(getDbfPath(HotSpiderSettings.localPath), qStrAvail);
                   dsAvailab.DataSetName = "Rooms";
                   dsAvailab.Tables[0].TableName = "Room";
                   // Transform Table to XML-String
                   StringWriter sw = new StringWriter();
                   UpdateAvailabData(dsAvailab.Tables[0]).WriteXml(sw);
                   return sw.ToString();
               }
       */
       
        public static string changeDateFormat(string date)
        {
            string newDate = "";
            string[] splittDate = date.Split('.');
            newDate = splittDate[2] + "-" + splittDate[1] + "-" + splittDate[0];
            return newDate;
        }

        public static DataTable ConvertCSVtoDataTable(string strFilePath)
        {
            DataTable dt = new DataTable();
            using (StreamReader sr = new StreamReader(strFilePath))
            {
                string[] headers = sr.ReadLine().Split(',');
                foreach (string header in headers)
                {
                    dt.Columns.Add(header);
                }
                while (!sr.EndOfStream)
                {
                    string[] rows = sr.ReadLine().Split(',');
                    DataRow dr = dt.NewRow();
                    for (int i = 0; i < headers.Length; i++)
                    {
                        // Datum formatieren
                        if (i == 1)
                        {
                            rows[i] = changeDateFormat(rows[i]);
                        }
                        dr[i] = rows[i];
                    }
                    dt.Rows.Add(dr);
                }
            }
            return dt;
        }

        public static void selectWhere(string selection)
        {
            string csvFilePath = HotSpiderSettings.ifcPath;
            int counter = 0;
            string result = "";
            string[] columnArray = null;
            string line = null;
            int column = 0;

            switch (selection)
            {
                case "Room":
                    column = 3;
                    break;
                case "Rate":
                    column = 2;
                    break;
                case "Restriction":
                    column = 1;
                    break;
                case "RoomLock":
                    column = 5;
                    break;
            }

            // Nur die ausgewählten Zeilen bleiebn erhalten und werden gespeichert
            StreamReader file = new StreamReader(csvFilePath + "avail_S.csv");
            while ((line = file.ReadLine()) != null)
            {
                // Die erste Zeile wird einfach übernommen
                if (counter == 0) result = line;
                // Alle weiteren Zeilen müssen für die Auswahl "WAHR" sein
                columnArray = line.Split(',');
                if ((columnArray[columnArray.Length - column].Equals("T")) ||
                    (columnArray[columnArray.Length - column].Equals("True")) ||
                    (columnArray[columnArray.Length - column].Equals(".T.")) ||
                    (columnArray[columnArray.Length - column].Equals("TRUE")) ||
                    (columnArray[columnArray.Length - column].Equals("true")) ||
                    (columnArray[columnArray.Length - column].Equals("t")) ||
                    (columnArray[columnArray.Length - column].Equals("WAHR")) ||
                    (columnArray[columnArray.Length - column].Equals("GESPERRT")) ||
                    (columnArray[columnArray.Length - column].Equals("gesperrt")) ||
                    (columnArray[columnArray.Length - column].Equals("Gesperrt"))) 
                    result = result + Environment.NewLine + line;
                counter++;
            }
            File.WriteAllText(csvFilePath + "xml\\avail_S_checked.csv", result);
            file.Close();
        }

        public static string txtToCsvFormat(string str)
        {
            str = str.Replace("\"", "");
            str = str.Replace(";", ",");
            str.Trim();
            return str;
        }

        public static string ReadCsvAsXML(string elementName, string chooseA, string chooseB, string chooseC)
        {
            string result = "";
            string xmlTempFile = HotSpiderSettings.ifcPath + "xml\\avail_S.xml";

            // CSV into DataTable
            DataSet dsAvailab = new DataSet();
            dsAvailab.Tables.Add(ConvertCSVtoDataTable(HotSpiderSettings.ifcPath + "xml\\avail_S_checked.csv"));
            // If DataTable not empty
            if (dsAvailab.Tables[0].Rows.Count == 0)
            {
                MessageBox.Show("Die Hotel-Spider Schnittstelle hat keine Daten erhalten. Bitte bestätigen oder wiederholen sie ihre Eingabe.", "Hotel-Spider");
                CloseApplication();
            }
            else
            {
                // Setze Tabellennamen ein
                dsAvailab.DataSetName = elementName + "s";
                dsAvailab.Tables[0].TableName = elementName;

                // Zwischenspeicherung der Tabelle als XML-Datei
                dsAvailab.Tables[0].WriteXml(xmlTempFile);

                // Transfomiere XML Dokument
                XslCompiledTransform xsltForm = new XslCompiledTransform();
                try
                {
                    // Lede entsprechende Transformationsdatei
                    if (elementName.Equals("Room")) 
                    {
                        if (File.Exists(HotSpiderSettings.ifcPath + "xslt\\CsvInv.xslt"))
                        {
                            xsltForm.Load(HotSpiderSettings.ifcPath + "xslt\\CsvInv.xslt");
                        }
                        else
                        {
                            WriteLog("Folgende Datei fehlt: " + HotSpiderSettings.ifcPath + "xslt\\CsvInv.xslt");
                            MessageBox.Show("Fehler beim Bearbeiten der Zimmer-Daten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                            CloseApplication();
                        }
                    }
                    else if (elementName.Equals("Rate")) 
                    {
                        if (File.Exists(HotSpiderSettings.ifcPath + "xslt\\CsvRate.xslt"))
                        {
                            xsltForm.Load(HotSpiderSettings.ifcPath + "xslt\\CsvRate.xslt");
                        }
                        else
                        {
                            WriteLog("Folgende Datei fehlt: " + HotSpiderSettings.ifcPath + "xslt\\CsvRate.xslt");
                            MessageBox.Show("Fehler beim Bearbeiten der Preis-Daten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                            CloseApplication();
                        }
                    }
                    else if (elementName.Equals("Restriction"))
                    {
                        if (File.Exists(HotSpiderSettings.ifcPath + "xslt\\CsvRest.xslt"))
                        {
                            xsltForm.Load(HotSpiderSettings.ifcPath + "xslt\\CsvRest.xslt");
                        }
                        else
                        {
                            WriteLog("Folgende Datei fehlt: " + HotSpiderSettings.ifcPath + "xslt\\CsvRest.xslt");
                            MessageBox.Show("Fehler beim Bearbeiten der Einschränkungs-Daten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                            CloseApplication();
                        }
                    }
                        
                    // Führe transformation aus
                    xsltForm.Transform(xmlTempFile, xmlTempFile + "_TEMP.xml");
                }
                catch (XsltException ex)
                {
                    WriteLog("Fehler beim Transformieren der XML-Dateien: " + ex);
                    MessageBox.Show("Fehler beim Bearbeiten der Zimmer-Daten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                    CloseApplication();
                }

                // Lade DataTable aus transfomierten XML-Datei      
                DataSet ds = new DataSet();
                ds.ReadXml(xmlTempFile + "_TEMP.xml");

                // ergänze Tabelle mit "bis"-Spalte)
                StringWriter sw = new StringWriter();
                UpdateAvailabData(ds.Tables[0], chooseA, chooseB, chooseC).WriteXml(sw);
                result = sw.ToString();
            }
            return result;
        }

        public static string ReadOleDbAsXML(string qStrAvail, string elementName, string chooseA, string chooseB, string chooseC)
        {
            string result = "";
            // Read DBF-DB         
            DataSet dsAvailab = new DataSet();
            dsAvailab = ReadOleDbTable(getPath(HotSpiderSettings.localPath, "LOG"), qStrAvail);

            if (dsAvailab.Tables[0].Rows.Count == 0)
            {
                MessageBox.Show("Die Hotel-Spider Schnittstelle hat keine Daten erhalten. Bitte bestätigen oder wiederholen sie ihre Eingabe.", "Hotel-Spider");
                CloseApplication();
            }
            else
            {
                dsAvailab.DataSetName = elementName + "s";
                dsAvailab.Tables[0].TableName = elementName;

                // ergänze Tabelle mit "von"- und "bis"-Spalte
                StringWriter sw = new StringWriter();
                UpdateAvailabData(dsAvailab.Tables[0], chooseA, chooseB, chooseC).WriteXml(sw);
//                UpdateAvailabData(FormatDateInDatatable(dsAvailab.Tables[0]), chooseA, chooseB, chooseC).WriteXml(sw);
                result = sw.ToString();
            }
            return result;
        }

/*        public static DataTable FormatDateInDatatable(DataTable dt)
        {
            // Create new "von" column
            DataColumn vonCol = dt.Columns.Add("von", typeof(String));
            foreach (DataColumn col in dt.Columns) col.ReadOnly = false;

            foreach (DataRow dr in dt.Rows)
            {
                foreach (DataColumn col in dt.Columns)
                {
                    if (col.DataType == typeof(System.String))
                    {
                        dr[col] = dr[col].ToString().Trim();
                    }
                }
                DateTime readDate = DateTime.Parse(dr["Datum"].ToString());
                dr["von"] = readDate.ToString("yyyy-MM-dd");
            }

            dt.Columns.Remove("Datum");
            foreach (DataColumn col in dt.Columns) col.ReadOnly = true;

            return dt;
        }
*/
        public static void prepaireXMLforString(string path)
        {
            var lines = File.ReadAllLines(path);
            File.WriteAllLines(path, lines.Skip(1).ToArray());
        }

        public static void TranformInv(string path, string type)
        {
            int counter = 1;
            XslCompiledTransform xsltInv = new XslCompiledTransform();
            try
            {
                if (File.Exists(path + "xslt\\IsendTo" + type + ".xslt"))
                {
                    xsltInv.Load(path + "xslt\\IsendTo" + type + ".xslt");

                    while (File.Exists(path + "xml\\HoRes_Data_" + type + ".xml_" + counter + ".xml"))
                    {
                        xsltInv.Transform(path + "xml\\HoRes_Data_" + type + ".xml_" + counter + ".xml", path + "xml\\Spider_" + type + ".xml_" + counter + ".xml");
                        counter++;
                    }
                }
                else
                {
                    WriteLog("Folgende Datei fehlt: " + path + "xslt\\IsendTo" + type + ".xslt");
                    MessageBox.Show("Fehler beim Bearbeiten der Daten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                    CloseApplication();
                }
                
            }
            catch (XsltException ex)
            {
                WriteLog("Fehler beim Transformieren der XML-Dateien: " + ex);
                MessageBox.Show("Fehler beim Bearbeiten der Zimmer-Daten. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                CloseApplication();
            }
            for (int i = 1; i <= counter - 1; i++)
            {
                prepaireXMLforString(path + "xml\\Spider_" + type + ".xml_" + i + ".xml");
            }
        }

        public static string XmlToCSV(string xmlString)
        {
            string output = "";

            // Create an XmlReader
            using (XmlReader reader = XmlReader.Create(new StringReader(xmlString)))
            {
                // Parse the file.
                while (reader.Read())
                {
                    if (reader.NodeType == XmlNodeType.EndElement && (reader.Name.Equals("Rooms") || reader.Name.Equals("Rates") || reader.Name.Equals("Restrictions")))
                    {
                        return output;
                    }
                    else if (reader.NodeType == XmlNodeType.Element && reader.Name.Equals("typ"))
                    {
                        if (output.Equals(""))
                        {
                            output = TimeStamp();
                        }
                        else
                        {
                            output = output + Environment.NewLine + TimeStamp();
                        }

                        /*                    switch (reader.Name)
                                            {
                                                case "Typ": 
                                                    output = output + Environment.NewLine;
                                       //             output = output + "Zimmertyp: ";
                                                    break;
                              /*                  case "Anz":
                                                    output = output + " Anzahl: ";
                                                    break;
                                                case "von":
                                                    output = output + " vom: ";
                                                    break;
                                                case "bis":
                                                    output = output + " bis zum: ";
                                                    break;
                                            }                      
                             */
                    }
                    else if (reader.NodeType == XmlNodeType.Text)
                    {
                        output = output + "," + reader.Value;
                    }
                }
                return output;
            }
        }

        // Für vorzeitiges Beenden des Programms
        public static void CloseApplication()
        {
            string spiderDirectory = getPath(HotSpiderSettings.localPath, "LOG");

            // Lösche die Schalter-Dateien  
            if (File.Exists(spiderDirectory + "room_U.dat")) File.Delete(spiderDirectory + "room_U.dat");
            if (File.Exists(spiderDirectory + "roomlock_U.dat")) File.Delete(spiderDirectory + "roomlock_U.dat");
            if (File.Exists(spiderDirectory + "price_U.dat")) File.Delete(spiderDirectory + "price_U.dat");
            if (File.Exists(spiderDirectory + "restrict_U.dat")) File.Delete(spiderDirectory + "restrict_U.dat");
            // Lösche die CSV-Datei, die von HoRes geschickt wird
            if (File.Exists(spiderDirectory + "avail_S.csv")) File.Delete(spiderDirectory + "avail_S.csv");
            // Lösche inUse-Datei - Signal
            if (File.Exists(spiderDirectory + "inUse.dat")) File.Delete(spiderDirectory + "inUse.dat");

            // Temporäre Daten im xml-Ordner werden gelöscht
            Array.ForEach(Directory.GetFiles(HotSpiderSettings.ifcPath + "xml\\"), File.Delete);

            if (System.Windows.Forms.Application.MessageLoop)
            {
                // WinForms app
                //           HotelInterfaceTools.WriteLog("HoRes Hotel-Spider Interface wurde beendet.");
                System.Windows.Forms.Application.Exit();
            }
            else
            {
                // Console app
                //          HotelInterfaceTools.WriteLog("HoRes Hotel-Spider Interface wurde beendet.");
                System.Environment.Exit(1);
            }
        }

        public static void SplittXml(string file, byte count, string name)
        {
            int index = 0;
            int counter = 0;
            int fullCounter = 0;
            try
            {
                XDocument xdoc = XDocument.Load(file);
                XElement newDoc = new XElement(name);

                foreach (var element in xdoc.Root.Elements())
                {
                    fullCounter++;
                    if ((counter < count - 1) && !(fullCounter > xdoc.Root.Elements().Count() - 1))
                    {
                        counter++;
                        newDoc.Add(element);
                    }
                    else
                    {
                        counter = 0;
                        newDoc.Add(element);
                        newDoc.Save(file + "_" + ++index + ".xml");
                        newDoc.RemoveAll();
                    }
                }
            }
            catch (XmlException ex)
            {
                WriteLog("Fehler beim Splitten von XML: " + ex);
                MessageBox.Show("Fehler beim Splitten von XML-Datei. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                CloseApplication();
            }
        }
    }
}
