﻿using System;
using System.IO;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Linq;
using Ifc;

namespace Spider
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            if (!File.Exists(HotSpiderSettings.settingsFile))
            {
                MessageBox.Show("Die Settings-Datei wurde nicht gefunden. Updates konnten nicht gesendet werden. Bitte wenden sie sich an den Support.", "Hotel-Spider - Fehlermeldung!");
                HotelInterfaceTools.CloseApplication();
            }
            else
            {
                if (HotelInterfaceTools.DnsTestSuc(HotSpiderSettings.dnsTestName))
                {
                    HotSpiderSettings.setConfiguration();
                    Start();
                }
                else
                {
                    string logFile = HotelInterfaceTools.getPath(HotSpiderSettings.localPath, "LOG") + "spider.Log";
                    HotelInterfaceTools.WriteLog("Error, Keine Internetverbindung.");
                    // Bei bleibenden Error-Meldungen wird die letzte Zeile der Log-Datei bearbeitet.               
                    if (HotelInterfaceTools.isLogStatus("Error", 1, "Keine Internetverbindung.", 2, logFile))
                        HotelInterfaceTools.RSuccessNoResDelLastLog("Error", "Keine Internetverbindung.", logFile, 2);
                    MessageBox.Show("Sie haben zur Zeit keine Internetverbindung. Überprüfen sie bitte ihren Internetanschluss.", "Hotel-Spider");
                    HotelInterfaceTools.CloseApplication();
                }   
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

        public static void Start()
        {
            Boolean sendWithoutProblems = true;
            
            Boolean sendRoomsOK = false;
            Boolean sendRatesOK = false;
            Boolean sendRestrictionsOK = false;
            Boolean sendRoomLocksOK = false;
            Boolean sendRoomLocksNotOK = false;
            Boolean sendRoomsNotOK = false;
            Boolean sendRatesNotOK = false;
            Boolean sendRestrictionsNotOK = false;

            Boolean successRS = false;
            Boolean fileThere = false;

            string spiderDLPath = HotelInterfaceTools.getPath(HotSpiderSettings.localPath, "LOG");
            string sourceFile = spiderDLPath + "avail_S.dbf";
            string sourceFileCSV = spiderDLPath + "avail_S.csv";

            string xmlMessage = "";

            string roomlockU = spiderDLPath + "roomlock_U.dat";
            string roomU = spiderDLPath + "room_U.dat";
            string priceU = spiderDLPath + "price_U.dat";
            string restrictU = spiderDLPath + "restrict_U.dat";

            /*           string qStrAvailRooms = "SELECT TRIM(Av_roomtyp) AS Typ, TRIM(Av_invcode) AS Typecode, TRIM(Av_waiting) AS Anz, TRIM(Av_countyp) AS countype, TRIM(Av_actype) AS actype, FORMAT(Av_date, 'YYYY-MM-DD') AS von FROM Avail_S WHERE Av_z = 'WAHR'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";         
                       string qStrAvailPrices = "SELECT TRIM(Av_roomtyp) AS Typ, TRIM(Av_invcode) AS Typecode, TRIM(Av_invtype) AS Invtype, TRIM(Av_ratcode) AS Preiscode,TRIM(Av_ratier) AS Preisschicht, TRIM(Av_statusp) AS statusP, TRIM(Av_anzgast) AS Gaesteanzahl, TRIM(Av_agecode) AS Alterscode, TRIM(Av_price) AS Preis, TRIM(Av_decimal) AS Deci, TRIM(Av_curency) AS Waehrung, FORMAT(Av_date, 'YYYY-MM-DD') AS von FROM Avail_S WHERE Av_p = 'WAHR'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";           
                       string qStrAvailRestrictions = "SELECT TRIM(Av_roomtyp) AS Typ, TRIM(Av_invcode) AS Typecode, TRIM(Av_ratcode) AS Preiscode, TRIM(Av_los) AS los, TRIM(Av_lostime) AS Dauer, TRIM(Av_reststa) AS Einschraenkung, TRIM(Av_statusr) AS statusR, FORMAT(Av_date, 'YYYY-MM-DD') AS von FROM Avail_S WHERE Av_r = 'WAHR'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";
            */

            string qStrAvailRoomLocks = "SELECT Av_roomtyp AS typ, Av_invcode AS typecode, Av_reststa AS actype, Av_date AS datum FROM Avail_S WHERE Av_reststa = 'GESPERRT'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";         

            string qStrAvailRooms = "SELECT Av_roomtyp AS typ, Av_invcode AS typecode, Av_waiting AS anz, Av_countyp AS countype, Av_actype AS actype, Av_date AS datum FROM Avail_S WHERE Av_z = 'WAHR'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";         
            string qStrAvailPrices = "SELECT Av_roomtyp AS typ, Av_invcode AS typecode, Av_invtype AS invtype, Av_ratcode AS preiscode, Av_ratier AS preisschicht, Av_statusp AS statusp, Av_anzgast AS gaesteanzahl, Av_agecode AS alterscode, Av_price AS preis, Av_decimal AS deci, Av_curency AS waehrung, Av_date AS datum FROM Avail_S WHERE Av_p = 'WAHR'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";           
            string qStrAvailRestrictions = "SELECT Av_roomtyp AS typ, Av_invcode AS typecode, Av_ratcode AS preiscode, Av_los AS los, Av_lostime AS dauer, Av_reststa AS einschraenkung, Av_statusr AS statusr, Av_date AS datum FROM Avail_S WHERE Av_r = 'WAHR'";  //Av_waiting > 0"; // AND Av_date >= #" + ConvertDBFDate(von) + "# AND Av_date <= #" + ConvertDBFDate(bis) + "#";


            string inUseDatei = spiderDLPath + "inUse.dat";

            // erstelle Schalterdatei inUse - Signal, dass Schnittstelle läuft
            File.WriteAllText(inUseDatei, "Die Hotel-Spider Schnittstelle wurde gestartet - bitte warten sie bis sie beeendet wird.");

            // Erstelle temporeren XML-Ordner, wenn nicht vorhanden, ggf. lösche alte Dateien
            string xmlPath = AppDomain.CurrentDomain.BaseDirectory + "xml\\";
            if (!Directory.Exists(xmlPath)) 
            {
                Directory.CreateDirectory(xmlPath);                
            }
            else if (Directory.GetFiles(xmlPath).Length > 0)
            {               
                // Temporäre Daten im xml-Ordner werden gelöscht, falls vor Programmstart noch da
                Array.ForEach(Directory.GetFiles(xmlPath), File.Delete);
            }           


            if (File.Exists(sourceFile) || File.Exists(sourceFileCSV))
            {
                if (File.Exists(sourceFileCSV))
                {
                    // VFPs TXT-data to CSV-data
                    String csvFileContent = File.ReadAllText(sourceFileCSV);
                    csvFileContent = csvFileContent.Replace(',', '.');
                    csvFileContent = HotSpiderSettings.avail_s + Environment.NewLine + csvFileContent;
                    File.WriteAllText(HotSpiderSettings.ifcPath + "avail_S.csv", HotelInterfaceTools.txtToCsvFormat(csvFileContent));
                }               

                // Wenn Zimmer aktuallisiert werden sollen
                if (File.Exists(roomU))
                {
                    fileThere = true;
                    // Kontingente werden aktualisiert
                    HotelInterfaceTools.WriteLog("Kontingente werden aktualisiert...");

                    // Daten werden aus der AVAIL_S.DBF bzw. der AVAIL_S.CSV geholt und als XML gespeichert
                    XElement xmlTreeHoResData;
                    if (HotSpiderSettings.oledb.Equals("T") && HotSpiderSettings.updates.Equals("T"))
                    {
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadOleDbAsXML(qStrAvailRooms, "Room", "typecode", "anz", "anz"));
                        xmlTreeHoResData.Save(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml");
                    }
                    else if (File.Exists(sourceFileCSV))
                    {                      
                        HotelInterfaceTools.selectWhere("Room");
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadCsvAsXML("Room", "typecode", "anz", "anz"));
                        xmlTreeHoResData.Save(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml");
                    }

                    // Schreibe zu aktualisierende Kontingente in Log
                    String invXmlString = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml");
                    // Eintrag in die Log-Datei
                    HotelInterfaceTools.WriteLog("Zu aktuallisierende Kontingente: " + Environment.NewLine + HotelInterfaceTools.XmlToCSV(invXmlString));

                    // Teile XML in fünfer Einheiten
                    HotelInterfaceTools.SplittXml(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml", 5, "Rooms");

                    // Transform HoRes-Data for Inventory and create XML-String to send
                    HotelInterfaceTools.TranformInv(HotSpiderSettings.ifcPath, "Inv");

                    // Folgende While-Schleife arbeitet die XML RQs in 5er-Schritten ab
                    int counter = 1;
                    successRS = true;
                    while (File.Exists(HotSpiderSettings.ifcPath + "xml\\Spider_Inv.xml_" + counter + ".xml") && successRS)
                    {
                        // Create String to send to Hotel-Spider to update inventories
                        xmlMessage = SpiderRQ.HotelInvCountNotifRQString(HotSpiderSettings.ifcPath + "\\xml\\Spider_Inv.xml_" + counter + ".xml");
                        
                        // Receive String from Hotel-Spider
                        string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.ch/ota/OTA_HotelInvCountNotif/2014A");
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://staging.hotel-spider.ch/ota/OTA_HotelInvCountNotif/2014A");


                        //// fuer Testzwecke
                        ////retrievedRes = File.ReadAllText(IfcSettings.ifcPath + "Reservation_Test.log");
                        //XmlDocument xmlDoc = new XmlDocument();
                        //xmlDoc.LoadXml(rsInvRSString);
                        //xmlDoc.Save(IfcSettings.ifcPath + "SendUpdatesRS.txt");


                        File.WriteAllText(HotSpiderSettings.ifcPath + "\\xml\\sendMessage.xml", xmlMessage);


                        // Check response (rsInvRSString) and write result to Log-File
                        if (HotelInterfaceTools.RSSuccess(rsInvRSString).Equals("Success"))
                        {
                            sendRoomsOK = true;
                            string sendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml_" + counter + ".xml");
                            // Eintrag in die Daten-Log-Datei der Zimmer
                            HotelInterfaceTools.WriteDataLog(HotelInterfaceTools.XmlToCSV(sendedUpdate), "Rooms");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\Spider_Inv.xml_" + counter + ".xml");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml_" + counter + ".xml");
                        }
                        else
                        {
                            sendRoomsNotOK = true;
                            successRS = false;
                            sendWithoutProblems = false;
                            string notSendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Inv.xml_" + counter + ".xml");
                            HotelInterfaceTools.WriteLog(rsInvRSString, "Ein Problem beim: " + counter + ". XML-Request ist aufgetreten. Nicht gesendet: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate));
                            HotelInterfaceTools.WriteLog(rsInvRSString);
                            MessageBox.Show("Ein Problem beim Senden einer Nachricht ist aufgetreten. Versuchen sie es bitte zu einem späteren Zeitpunkt erneut. Wenn der Fehler weiterhin auftritt, dann wenden sie sich bitte an den Support. Folgende Aktualisierung war nicht erfolgreich: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate), "Hotel-Spider - Fehlermeldung!");
                        }
                        counter++;
                    }

                    // Wenn kein Fehler aufgetreten ist
                    if (successRS)
                    {
                        HotelInterfaceTools.WriteLog("Kontingente wurden erfolgreich aktualisiert.");
                    }

                    // Lösche Datums-Datei
                    File.Delete(roomU);
                }

                // Falls es zu Fehlern kam
                successRS = false;

                // Wenn Zimmer gesperrt werden sollen
                if (File.Exists(roomlockU))
                {
                    fileThere = true;
                    // Zimmer werden gesperrt
                    HotelInterfaceTools.WriteLog("Zimmer werden gesperrt...");

                    // Daten werden aus der AVAIL_S.DBF bzw. der AVAIL_S.CSV geholt und als XML gespeichert
                    XElement xmlTreeHoResData;
                    if (HotSpiderSettings.oledb.Equals("T") && HotSpiderSettings.updates.Equals("T"))
                    {
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadOleDbAsXML(qStrAvailRoomLocks, "Room", "typecode", "actype", "actype"));
                    }
                    else
                    {
                        HotelInterfaceTools.selectWhere("RoomLock");
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadCsvAsXML("Room", "typecode", "actype", "actype"));
                    }
                    xmlTreeHoResData.Save(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Lock.xml");

                    // Schreibe zu aktualisierende Kontingente in Log
                    String invXmlString = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Lock.xml");
                    // Eintrag in die Log-Datei
                    HotelInterfaceTools.WriteLog("Zu sperrende Zimmer: " + Environment.NewLine + HotelInterfaceTools.XmlToCSV(invXmlString));

                    // Teile XML in fünfer Einheiten
                    HotelInterfaceTools.SplittXml(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Lock.xml", 5, "Rooms");

                    // Transform HoRes-Data for Inventory and create XML-String to send
                    HotelInterfaceTools.TranformInv(HotSpiderSettings.ifcPath, "Lock");

                    // Folgende While-Schleife arbeitet die XML RQs in 5er-Schritten ab
                    int counter = 1;
                    successRS = true;
                    while (File.Exists(HotSpiderSettings.ifcPath + "xml\\Spider_Lock.xml_" + counter + ".xml") && successRS)
                    {
                        // Create String to send to Hotel-Spider to update inventories
                        xmlMessage = SpiderRQ.HotelInvCountNotifRQString(HotSpiderSettings.ifcPath + "\\xml\\Spider_Lock.xml_" + counter + ".xml");

                        // Receive String from Hotel-Spider
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.com/shared/ota/2009A/OTA_HotelInvCountNotif.php");
                        string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.ch/ota/OTA_HotelInvCountNotif/2014A");
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://staging.hotel-spider.ch/ota/OTA_HotelInvCountNotif/2014A");


                        // Check response (rsInvRSString) and write result to Log-File
                        if (HotelInterfaceTools.RSSuccess(rsInvRSString).Equals("Success"))
                        {
                            sendRoomLocksOK = true;
                            string sendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Lock.xml_" + counter + ".xml");
                            // Eintrag in die Daten-Log-Datei der Zimmer
                            HotelInterfaceTools.WriteDataLog(HotelInterfaceTools.XmlToCSV(sendedUpdate), "Rooms");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\Spider_Lock.xml_" + counter + ".xml");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Lock.xml_" + counter + ".xml");
                        }
                        else
                        {
                            sendRoomLocksNotOK = true;
                            successRS = false;
                            sendWithoutProblems = false;
                            string notSendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Lock.xml_" + counter + ".xml");
                            HotelInterfaceTools.WriteLog(rsInvRSString, "Ein Problem beim: " + counter + ". XML-Request ist aufgetreten. Nicht gesendet: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate)); HotelInterfaceTools.WriteLog(rsInvRSString, "Ein Problem beim: " + counter + ". XML-Request ist aufgetreten. Nicht gesendet: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate));
                            HotelInterfaceTools.WriteLog(rsInvRSString);
                            MessageBox.Show("Ein Problem beim Senden einer Nachricht ist aufgetreten. Versuchen sie es bitte zu einem späteren Zeitpunkt erneut. Wenn der Fehler weiterhin auftritt, dann wenden sie sich bitte an den Support. Folgende Aktualisierung war nicht erfolgreich: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate), "Hotel-Spider - Fehlermeldung!");
                        }
                        counter++;
                    }

                    // Wenn kein Fehler aufgetreten ist
                    if (successRS)
                    {
                        HotelInterfaceTools.WriteLog("Zimmer wurden erfolgreich gesperrt.");
                    }

                    // Lösche Datums-Datei
                    File.Delete(roomlockU);
                }

                // Falls es zu Fehlern kam
                successRS = false;

                // Falls Preise aktuallisiert werden sollen
                if (File.Exists(priceU))
                {
                    fileThere = true;
                    // Kontingente werden aktualisiert
                    HotelInterfaceTools.WriteLog("Preise werden aktualisiert...");

                    // Daten werden aus der AVAIL_S.DBF bzw. der AVAIL_S.CSV geholt und als XML gespeichert
                    XElement xmlTreeHoResData;
                    if (HotSpiderSettings.oledb.Equals("T") && HotSpiderSettings.updates.Equals("T"))
                    {
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadOleDbAsXML(qStrAvailPrices, "Rate", "typecode", "preiscode", "preisschicht"));
                    }
                    else
                    {                      
                        HotelInterfaceTools.selectWhere("Rate");
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadCsvAsXML("Rate", "typecode", "preiscode", "preisschicht"));
                    }
                    xmlTreeHoResData.Save(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml");

                    // Ersetze Komma mit Punkt beim Preis
                    String rateXmlString = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml");
                    rateXmlString = rateXmlString.Replace(',', '.');
                    File.WriteAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml", rateXmlString);

                    // Eintrag in die Log-Datei
                    HotelInterfaceTools.WriteLog("Zu aktuallisierende Preise: " + Environment.NewLine + HotelInterfaceTools.XmlToCSV(rateXmlString));

                    // Teile XML in fünfer Einheiten
                    HotelInterfaceTools.SplittXml(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml", 5, "Rates");

                    // Transform HoRes-Data for Inventory and create XML-String to send
                    HotelInterfaceTools.TranformInv(HotSpiderSettings.ifcPath, "Rate");

                    // Folgende While-Schleife arbeitet die XML RQs in 5er-Schritten ab
                    int counter = 1;
                    successRS = true;
                    while (File.Exists(HotSpiderSettings.ifcPath + "xml\\Spider_Rate.xml_" + counter + ".xml") && successRS)
                    {
                        // Create String to send to Hotel-Spider to update inventories
                        xmlMessage = SpiderRQ.HotelRatePlanNotifRQString(HotSpiderSettings.ifcPath + "\\xml\\Spider_Rate.xml_" + counter + ".xml");

                        // Receive String from Hotel-Spider
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.com/shared/ota/2009A/OTA_HotelRatePlanNotif.php");
                        string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.ch/ota/OTA_HotelRatePlanNotif/2014A");
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://staging.hotel-spider.ch/ota/OTA_HotelRatePlanNotif/2014A");


                        // Check response (rsInvRSString) and write result to Log-File
                        if (HotelInterfaceTools.RSSuccess(rsInvRSString).Equals("Success"))
                        {
                            sendRatesOK = true;
                            string sendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml_" + counter + ".xml");
                            // Eintrag in die Daten-Log-Datei der Zimmer
                            HotelInterfaceTools.WriteDataLog(HotelInterfaceTools.XmlToCSV(sendedUpdate), "Rates");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\Spider_Rate.xml_" + counter + ".xml");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml_" + counter + ".xml");
                        }
                        else
                        {
                            sendRatesNotOK = true;
                            successRS = false;
                            sendWithoutProblems = false;
                            string notSendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rate.xml_" + counter + ".xml");
                            HotelInterfaceTools.WriteLog(rsInvRSString, "Ein Problem beim: " + counter + ". XML-Request ist aufgetreten. Nicht gesendet: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate));
                            HotelInterfaceTools.WriteLog(rsInvRSString);
                            MessageBox.Show("Ein Problem beim Senden einer Nachricht ist aufgetreten. Versuchen sie es bitte zu einem späteren Zeitpunkt erneut. Wenn der Fehler weiterhin auftritt, dann wenden sie sich bitte an den Support. Folgende Aktualisierung war nicht erfolgreich: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate), "Hotel-Spider - Fehlermeldung!");
                        }
                        counter++;
                    }

                    // Wenn kein Fehler aufgetreten ist
                    if (successRS)
                    {
                        HotelInterfaceTools.WriteLog("Preise wurden erfolgreich aktualisiert.");
                    }

                    // Lösche Datums-Datei
                    File.Delete(priceU);
                }
               
                // Falls Einschränkungen aktualisiert werden sollen
                if (File.Exists(restrictU))
                {
                    fileThere = true;
                    // Kontingente werden aktualisiert
                    HotelInterfaceTools.WriteLog("Einschränkungen werden aktualisiert...");

                    // Daten werden aus der AVAIL_S.DBF bzw. der AVAIL_S.CSV geholt und als XML gespeichert
                    XElement xmlTreeHoResData;
                    if (HotSpiderSettings.oledb.Equals("T") && HotSpiderSettings.updates.Equals("T"))
                    {
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadOleDbAsXML(qStrAvailRestrictions, "Restriction", "typecode", "preiscode", "preiscode"));
                    }
                    else
                    {
                        HotelInterfaceTools.selectWhere("Restriction");
                        xmlTreeHoResData = XElement.Parse(HotelInterfaceTools.ReadCsvAsXML("Restriction", "typecode", "preiscode", "preiscode"));
                    }
                    xmlTreeHoResData.Save(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rest.xml");

                    // Schreibe zu aktualisierende Kontingente in Log
                    String restrictXmlString = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rest.xml");
                    // Eintrag in die Log-Datei
                    HotelInterfaceTools.WriteLog("Zu aktuallisierende Einschränkungen: " + Environment.NewLine + HotelInterfaceTools.XmlToCSV(restrictXmlString));

                    // Teile XML in fünfer Einheiten
                    HotelInterfaceTools.SplittXml(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rest.xml", 5, "Restrictions");

                    // Transform HoRes-Data for Inventory and create XML-String to send
                    HotelInterfaceTools.TranformInv(HotSpiderSettings.ifcPath, "Rest");

                    // Folgende While-Schleife arbeitet die XML RQs in 5er-Schritten ab
                    int counter = 1;
                    successRS = true;
                    while (File.Exists(HotSpiderSettings.ifcPath + "xml\\Spider_Rest.xml_" + counter + ".xml") && successRS)
                    {
                        // Create String to send to Hotel-Spider to update inventories
                        xmlMessage = SpiderRQ.HotelBookingRuleNotifRQString(HotSpiderSettings.ifcPath + "\\xml\\Spider_Rest.xml_" + counter + ".xml");
                        
                        // Receive String from Hotel-Spider
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.com/shared/ota/2009A/OTA_HotelBookingRuleNotif.php");
                        string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://extranet.hotel-spider.ch/ota/OTA_HotelBookingRuleNotif/2014A");
                        //string rsInvRSString = HotelInterfaceTools.SendRQandGetRS(xmlMessage, "https://staging.hotel-spider.ch/ota/OTA_HotelBookingRuleNotif/2014A");

                        // Check response (rsInvRSString) and write result to Log-File
                        if (HotelInterfaceTools.RSSuccess(rsInvRSString).Equals("Success"))
                        {
                            sendRestrictionsOK = true;
                            string sendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rest.xml_" + counter + ".xml");
                            // Eintrag in die Daten-Log-Datei der Zimmer
                            HotelInterfaceTools.WriteDataLog(HotelInterfaceTools.XmlToCSV(sendedUpdate), "Restrictions");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\Spider_Rest.xml_" + counter + ".xml");
                            File.Delete(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rest.xml_" + counter + ".xml");
                        }
                        else
                        {
                            sendRestrictionsNotOK = true;
                            successRS = false;
                            sendWithoutProblems = false;
                            string notSendedUpdate = File.ReadAllText(HotSpiderSettings.ifcPath + "xml\\HoRes_Data_Rest.xml_" + counter + ".xml");
                            HotelInterfaceTools.WriteLog(rsInvRSString, "Ein Problem beim: " + counter + ". XML-Request ist aufgetreten. Nicht gesendet: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate));
                            HotelInterfaceTools.WriteLog(rsInvRSString);
                            MessageBox.Show("Ein Problem beim Senden einer Nachricht ist aufgetreten. Versuchen sie es bitte zu einem späteren Zeitpunkt erneut. Wenn der Fehler weiterhin auftritt, dann wenden sie sich bitte an den Support. Folgende Aktualisierung war nicht erfolgreich: " + HotelInterfaceTools.XmlToCSV(notSendedUpdate), "Hotel-Spider - Fehlermeldung!");
                        }
                        counter++;
                    }

                    // Wenn kein Fehler aufgetreten ist
                    if (successRS)
                    {
                        HotelInterfaceTools.WriteLog("Einschränkungen wurden erfolgreich aktualisiert.");
                    }

                    // Lösche Datums-Datei
                    File.Delete(restrictU);
                }
            }
            else
            {
                sendWithoutProblems = false;
                HotelInterfaceTools.WriteLog("Daten konnten nicht bearbeitet werden, da die Datei: " + sourceFileCSV + " oder " + sourceFile + " fehlt.");
                MessageBox.Show("Ein Hotel-Spider Update hat nicht stattgefunden! Bitte kontaktieren sie den Support.", "Hotel-Spider - Warnung!");
                HotelInterfaceTools.CloseApplication();
            }

            // Lösche inUse-Datei
            if (File.Exists(inUseDatei)) File.Delete(inUseDatei);

            if ((sendWithoutProblems) && ((sendRoomsOK) || (sendRatesOK) || (sendRestrictionsOK) || (sendRoomLocksOK)))
            {
                MessageBox.Show("Die Übertragung der Daten war erfolgreich!", "Hotel-Spider");
            }
            else
            {       
                if (fileThere)
                {
                    MessageBox.Show("Achtung! Ein Problem ist aufgetreten. Teilweise wurden Daten jedoch erfolgreich aktualisiert! Drücken sie bitte OK, um weitere Informationen zu erhalten.", "Hotel-Spider");
                    if (sendRoomsOK) MessageBox.Show("Zimmer wurden erfolgreich aktualisiert! Drücken sie bitte OK, um weitere Informationen zu erhalten.", "Hotel-Spider");
                    if (sendRatesOK) MessageBox.Show("Preise wurden erfolgreich aktualisiert! Drücken sie bitte OK, um weitere Informationen zu erhalten.", "Hotel-Spider");
                    if (sendRestrictionsOK) MessageBox.Show("Einschränkungen wurden erfolgreich aktualisiert! Drücken sie bitte OK, um weitere Informationen zu erhalten.", "Hotel-Spider");
                    if (sendRoomLocksOK) MessageBox.Show("Zimmer wurden erfolgreich gesperrt! Drücken sie bitte OK, um weitere Informationen zu erhalten.", "Hotel-Spider");

                    if (sendRoomLocksNotOK) MessageBox.Show("Bei der Sperrung der Zimmer ist ein Problem aufgetreten! Bitte versuchen sie es zu einem späteren Zeitpunkt erneut. Wenn es weiterhin Probleme bei der Übertragung gibt, dann wenden sie sich bitte an den Support.", "Hotel-Spider");
                    if (sendRoomsNotOK) MessageBox.Show("Bei der Übertragung der Zimmer ist ein Problem aufgetreten! Bitte versuchen sie es zu einem späteren Zeitpunkt erneut. Wenn es weiterhin Probleme bei der Übertragung gibt, dann wenden sie sich bitte an den Support.", "Hotel-Spider");
                    if (sendRatesNotOK) MessageBox.Show("Bei der Übertragung der Preise ist ein Problem aufgetreten! Bitte versuchen sie es zu einem späteren Zeitpunkt erneut. Wenn es weiterhin Probleme bei der Übertragung gibt, dann wenden sie sich bitte an den Support.", "Hotel-Spider");
                    if (sendRestrictionsNotOK) MessageBox.Show("Bei der Übertragung der Einschränkungen ist ein Problem aufgetreten! Bitte versuchen sie es zu einem späteren Zeitpunkt erneut. Wenn es weiterhin Probleme bei der Übertragung gibt, dann wenden sie sich bitte an den Support.", "Hotel-Spider");
                }
                else
                {                   
                    HotelInterfaceTools.WriteLog("HoRes hat keine Schalterdatei für die Schnittstelle zur Verfügung gestellt.");
                    MessageBox.Show("Bei der Übertragung der Daten ist ein Problem aufgetreten! Bitte wenden sie sich an den Support.", "Hotel-Spider");
                }
            }
            // Programm wird beeendet
            HotelInterfaceTools.CloseApplication();
        }
    }
}
